100  REMark ******************************************
110  REMark *         Q L  C O M M A N D E R         *
120  REMark *                                        *
130  REMark *              version 2.0               *
140  REMark *          code date 2019.05.03          *
150  REMark *                                        *
160  REMark *              Andrei Tenu               *
170  REMark *              Martyn Hill               *
180  REMark ******************************************
1000 REMark :
1010 REMark *** QLiberator Directives...
1020 REMark $$stak=5120
1030 REMark *** TURBO Directives...   - also comment line 1370! And modify line 3010
1040 TURBO_locstr "R"
1050 TURBO_ref
1060 TURBO_windo 2
1070 TURBO_optim "B"
1080 TURBO_model 1
1090 TURBO_struct "S"
1100 TURBO_diags "I"
1110 TURBO_list "YES"
1120 TURBO_sound "YES"
1130 TURBO_objdat 64
1140 TURBO_buffersz 16
1150 TURBO_objstk 512
1160 TURBO_taskn "QLC v2.0"
1170 TURBO_objfil "win1_QLCommander_QLC_exe"
1180 TURBO_repfil "win1_QLCommander_QLCv20_rpt"
1190 REMark WHEN ERRor
1200 REMark INK#1,2:PRINT #1,'Error at line: ';ERLIN:REPORT:STOP
1210 REMark END WHEN
1220 REMark MODE 4: PAPER#0,0:PAPER#1,0:PAPER#2,0:BORDER#1,0:CLS#1
1230 REMark WINDOW#1,488,220,12,0
1240 :
1250 qlcVer$="2.0"
1260 REMark Make sure that guardian window covers all screen, in all resolutions
1270 IF VER$="HBA" THEN
1280   maxWinWid%=SCR_XLIM
1290   maxWinHgt%=SCR_YLIM
1300 ELSE
1310   maxWinWid%=512
1320   maxWinHgt%=256
1330   REMark make sure we are in monitor mode 4, otherwise it will crash
1340   WMON:MODE 4: PAPER#0,0:PAPER#1,0:BORDER#1,0:CLS#1:CLS#0
1350 END IF
1360 REMark comment next line if compiled with Turbo !
1370 PAPER#0,0:BORDER#0,0:PAPER#1,0:BORDER#1,0:PAPER#2,0:BORDER#2,0:CLS#0:CLS#1:CLS#2
1380 WINDOW#0,maxWinWid%,maxWinHgt%,0,0
1390 OUTLN #0,maxWinWid%,maxWinHgt%,0,0,0,0,0
1400 :
1410 readConfig
1420 InitialiseVars
1430 OpenWindows
1440 DrawWindows 1
1450 MainLoop
1460 CloseProgram
1470 :
1480 STOP
1490 :
1500 REMark -----------------------------------------------------------------------
1510 DEFine PROCedure StopWithError(errorMessage$)
1520   BEEP 1390*2, 20
1530   CLS #0
1540   PRINT #0, errorMessage$
1550   PAUSE 50*2
1560   :
1570   CloseProgram
1580   STOP
1590 END DEFine StopWithError
1600 :
1610 REMark -----------------------------------------------------------------------
1620 DEFine PROCedure CloseProgram
1630  LOCal ch%
1640   FOR ch%=3 TO 9 : CLOSE#ch% : END FOR ch%
1650   :
1660   IF headBuff>0 THEN RECHP(headBuff)
1670   IF titleFountBase>0 THEN RECHP titleFountBase: END IF
1680   IF mainFountBase>0 THEN RECHP mainFountBase: END IF
1690   IF comFountBase>0 THEN RECHP comFountBase: END IF
1700   :
1710   DATA_USE initialDATAD$
1720   WINDOW#0,maxWinWid%,maxWinHgt%,0,0:PAPER#0,0: INK#0,White%:CLS#0
1730   WINDOW#0,512,50,0,206: BORDER#0,1,1,7,0: CLS#0
1740   WINDOW#1,256,202,256,0: BORDER#1,1,1,7,0:PAPER#1,7: INK#1,0:CLS#1
1750   WINDOW#2,256,202,0,0: BORDER#2,1,1,7,0:PAPER#2,2: INK#2,7:CLS#2
1760 END DEFine CloseProgram
1770 REMark -----------------------------------------------------------------------
1780 DEFine PROCedure OpenWindows
1790  LOCal ch%,titleFountFN$(36),titleFountLen%,mainFountFN$(36),mainFountLen%
1800  LOCal comFountFN$(36),comFountLen%
1810   stdFountWid%=6
1820   :
1830   FOR ch%=3 TO 9 : OPEN#ch%,con : END FOR ch%
1840   :
1850   titleFountWid%=stdFountWid%
1860   titleFountBase=0
1870   titleFountFN$=ConfigDrv$&'bold8_fnt'
1880   IF FTEST(titleFountFN$) = 0 THEN
1890     titleFountLen%=FLEN(\titleFountFN$)
1900     IF titleFountLen%>0 THEN
1910       titleFountBase = ALCHP(titleFountLen%)
1920       LBYTES titleFountFN$, titleFountBase
1930       titleFountWid%=8
1940       CHAR_USE #titleWin%,titleFountBase,0
1950       CSIZE #titleWin%,1,0
1960       CHAR_INC #titleWin%,titleFountWid%,10
1970     END IF
1980   END IF
1990   :
2000   mainFountWid%=stdFountWid%
2010   mainFountBase=0
2020   mainFountFN$=ConfigDrv$&'5Pixel_fnt'
2030   IF FTEST(mainFountFN$) = 0 THEN
2040     mainFountLen%=FLEN(\mainFountFN$)
2050     IF mainFountLen%>0 THEN
2060       mainFountBase = ALCHP(mainFountLen%)
2070       LBYTES mainFountFN$,mainFountBase
2080     END IF
2090   END IF
2100   SELect ON ClassicFont%
2110     =0 : IF mainFountBase>0 THEN
2120            mainFountWid%=5: mainFountHeight%=10
2130            CHAR_USE #leftPanelWin%,mainFountBase,0
2140            CHAR_INC #leftPanelWin%,mainFountWid%,10
2150            CHAR_USE #rightPanelWin%,mainFountBase,0
2160            CHAR_INC #rightPanelWin%,mainFountWid%,10
2170          ELSE
2180            mainFountWid%=6: mainFountHeight%=10:comFountWid%=stdFountWid%
2190          END IF
2200     =1 : CSIZE #leftPanelWin%,0,0 : CSIZE #rightPanelWin%,0,0
2210          mainFountWid%=6: mainFountHeight%=10:comFountWid%=stdFountWid%
2220     =2 : mainFountWid%=8: mainFountHeight%=20:comFountWid%=8:titleFountWid%=16
2230          CSIZE #leftPanelWin%,1,1 : CSIZE #rightPanelWin%,1,1 : CSIZE #titleWin%,3,1:CSIZE #4,1,1: CSIZE #5,1,1: CSIZE #6,1,1:CSIZE #9,1,1
2240     =3 : mainFountWid%=12: mainFountHeight%=20:titleFountWid%=16:comFountWid%=8
2250          CSIZE #leftPanelWin%,2,1 : CSIZE #rightPanelWin%,2,1 : CSIZE #titleWin%,3,1:CSIZE #4,2,1: CSIZE #5,2,1: CSIZE #6,2,1:CSIZE #9,1,1
2260   END SELect
2270   remark comFountWid%=stdFountWid%
2280   comFountBase=0
2290   comFountFN$=ConfigDrv$&'qlc_fnt'
2300   IF FTEST(comFountFN$) = 0 THEN
2310     comFountLen%=FLEN(\comFountFN$)
2320     IF comFountLen%>0 THEN
2330       comFountBase = ALCHP(comFountLen%)
2340       LBYTES comFountFN$, comFountBase
2350       CHAR_USE #comWin%,comFountBase,0
2360     END IF
2370   END IF
2380   :
2390 END DEFine OpenWindows
2400 REMark -----------------------------------------------------------------------
2410 DEFine PROCedure DrawWindows (reload%)
2420   REMark reload%=1 we reload the file lists and draw the windows;
2430   REMark reload%==0 we do not reload the file lists, just redraw the windows
2440  LOCal left%
2450   :
2460   IF (linelen% * mainFountWid% + 2) > (maxWinWid% DIV 2) THEN
2470     linelen%=((maxWinWid% DIV 2) - 4) DIV mainFountWid%
2480   END IF
2490   panelWinWid%=linelen% * mainFountWid% + 2
2500   comWinWid%=  2 * panelWinWid%
2510   left%=(maxWinWid% - 2*panelWinWid%) DIV 2
2520   :
2530   REMark title line
2540   WINDOW#3, 2*panelWinWid%,mainFountHeight%+2,left%,5: BORDER#3, 1,TitleBorder%: PAPER#3, TitleBorder%,TitleBk%,1: CLS#3
2550   PAPER#3, 0: INK#3, 2
2560   if classicFont%>=2 then CSIZE #titleWin%,3,1 :else CSIZE #titleWin%,1,0
2570   CHAR_INC #titleWin%,titleFountWid%,10
2580   BLOCK#3, titleFountWid%*14,mainFountHeight%,(2*panelWinWid%-4-14*titleFountWid%)DIV 2,0,0
2590   CURSOR#3, (2*panelWinWid%-4 - 14*titleFountWid%) DIV 2,0:PRINT#3, ' QL COMMANDER '
2600   :
2610   REMark Drive line
2620   WINDOW#4,2*panelWinWid%,mainFountHeight%+2,left%,mainFountHeight%+7:PAPER#4,brd%:INK#4,0:BORDER#4,1,brd%:CLS#4
2630   AT#4,0,0:INK#4,2:PRINT#4,'D':AT#4,0,1:INK#4,0:PRINT#4,'ir'
2640   CURSOR#4,panelWinWid%,0:PRINT#4,'Di':INK#4,2:CURSOR#4,panelWinWid%+mainFountWid%*2,0:PRINT#4,'r'
2650   :
2660   REMark left dir
2670   WINDOW#5,panelWinWid%-4*mainFountWid%,mainFountHeight%,left%+4*mainFountWid%-2,mainFountHeight%+8:PAPER#5,White%:INK#5,0:BORDER#5,0:CLS#5
2680   PRINT#5,leftDir$
2690   :
2700   REMark right dir
2710   WINDOW#6,panelWinWid%-4*mainFountWid%,mainFountHeight%,left%+panelWinWid%+4*mainFountWid%-2,mainFountHeight%+8:PAPER#6,White%:INK#6,0:BORDER#6,0:CLS#6
2720   PRINT#6,rightDir$
2730   :
2740   panelWinHeight%=rowno%*mainFountHeight%+3
2750   IF panelWinHeight%+3*mainFountHeight%+19 >maxWinHgt% THEN
2760     rowno%=(maxWinHgt%-3*mainFountHeight%- 22)DIV mainFountHeight%
2770     panelWinHeight%=rowno%*mainFountHeight%+3
2780   END IF
2790   REMark left file panel
2800   WINDOW#7, panelWinWid%,panelWinHeight%,left%,2*mainFountHeight%+9: PAPER#7, ppr%: INK#7, ik%:BORDER#7, 1,brd%:CLS#7
2810   :
2820   REMark Right file panel
2830   WINDOW#8, panelWinWid%,panelWinHeight%,panelWinWid%+left%,2*mainFountHeight%+9: PAPER#8, ppr%: INK#8, ik%:BORDER#8, 1,brd%:CLS#8
2840   :
2850   REMark Commands line
2860   WINDOW#9, 2*panelWinWid%,mainFountHeight%+2,left%,panelWinHeight%+3*mainFountHeight%+7:PAPER#9, brd%: INK#9, White%:BORDER#9, 1,brd%:CLS#9
2870   WriteCommands comWin%
2880   :
2890   crtPanel%=leftPanelWin%
2900   IF reload%=1 THEN
2910     LShowLeftDir
2920     LShowRightDir
2930   ELSE
2940     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
2950     ListFiles RightFiles$, RStartPos%, RIndex%, 8
2960   END IF
2970 END DEFine DrawWindows
2980 REMark -----------------------------------------------------------------------
2990 DEFine PROCedure readConfig
3000 LOCal a$(42), Chan%
3010 ConfigDrv$=OPTION_CMD$:REMark CMD$
3020 IF ConfigDrv$="" THEN ConfigDrv$='win1_QLCommander_'
3030 a$=ConfigDrv$&'qlc_cfg'
3040 Chan%=FOP_IN(a$)
3050 IF Chan%>0
3060   INPUT #Chan%, MaxFiles%
3070   INPUT #Chan%, TempDir$
3080   INPUT #Chan%, leftDir$
3090   INPUT #Chan%, rightDir$
3100   INPUT #Chan%, Qubide%
3110   INPUT #Chan%, ClassicFont%
3120   INPUT #Chan%, linelen%
3130   INPUT #Chan%, rowno%
3140   INPUT #Chan%, Xchangepath$
3150   INPUT #Chan%, Xchangeprog$
3160   INPUT #Chan%, EditPath$
3170   INPUT #Chan%, Editprog$
3180   INPUT #Chan%, QLColors%
3190   CLOSE #Chan%
3200 ELSE
3210   CLS
3220   PRINT 'Config file not found - using default values ! '
3230   MaxFiles%=256
3240   TempDir$='win1_temp_'
3250   leftDir$='win1_'
3260   rightDir$='win1_'
3270   Qubide%=0
3280   ClassicFont%=1
3290   linelen%=40
3300   rowno%=20
3310   Xchangepath$=''
3320   Xchangeprog$=''
3330   EditPath$=''
3340   Editprog$=''
3350   QLColors=1
3360   PAUSE 100
3370   CLS
3380 END IF
3390 IF RMODE<=8 OR QLColors%=1 THEN
3400   IF VER$='HBA' AND RMODE>4 THEN COLOUR_QL:SetPalletteQL : END IF
3410   ppr%=0: brd%=4: ik%=7: strp%=7: White%=7:Green%=4:PPR9a%=2:ppr9b%=0:TitleBorder%=4: TitleBk%=0
3420 ELSE
3430   COLOUR_PAL: ppr%=4: brd%=13: ik%=1: strp%=13:White%=1:Green%=3:PPR9a%=72:ppr9b%=76:TitleBorder%=13:TitleBk%=4
3440 END IF
3450 IF maxWinHgt%=256 AND ClassicFont%>1 THEN ClassicFont%=1: END IF
3460 END DEFine readConfig
3470 REMark -----------------------------------------------------------------------
3480 DEFine PROCedure InitialiseVars
3490   titleWin%=3 : leftPanelWin%=7 : rightPanelWin%=8 : comWin%=9
3500   LSizedir%=0: LSizeFile%=0: crtPanel%=leftPanelWin%
3510   RSizedir%=0: RSizeFile%=0
3520   :
3530   maxFNLen%=36
3540   :
3550   _fLen%=maxFNLen%+3 : _fTyp%=maxFNLen%+7
3560   _fDat%=maxFNLen%+9 : _fPar%=maxFNLen%+13
3570   _fFlg%=maxFNLen%+15: _fMax%=maxFNLen%+16
3580   :
3590   _dPar%=maxFNLen%+3 : _dNxt%=maxFNLen%+5
3600   _dChd%=maxFNLen%+7 : _dFlg%=maxFNLen%+9
3610   _dMax%=maxFNLen%+10
3620   :
3630   DIM cmdText$(9,9) : REMark Used by WriteCommands
3640   cmdText$(1)=CHR$(1)        &' View'
3650   cmdText$(2)=CHR$(2)        &' Copy'
3660   cmdText$(3)=CHR$(3)        &' Rename'
3670   cmdText$(4)=CHR$(4)        &' Delete'
3680   cmdText$(5)=CHR$(5)        &' MkDir'
3690   cmdText$(6)=CHR$(7)&CHR$(1)&' Edit'
3700   cmdText$(7)=CHR$(7)&CHR$(2)&' Info'
3710   cmdText$(8)=CHR$(7)&CHR$(3)&' Comp'
3720   cmdText$(9)=CHR$(7)&CHR$(5)&' Exit'
3730   :
3740   initialDATAD$=DATAD$
3750   :
3760   headSz%=64
3770   headBuff=ALCHP(headSz%)
3780   IF headBuff<0 THEN StopWithError("Can't allocate memory for File-header Buffer.")
3790   :
3800 END DEFine InitialiseVars
3810 REMark -----------------------------------------------------------------------
3820 DEFine PROCedure LShowLeftDir
3830 LOCal i%
3840 REMark DIM LeftFiles$(MaxFiles%,2,36)
3850 DIM LeftFiles$(MaxFiles%,_fMax%)
3860 LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
3870 IF LEN(leftDir$)=5 THEN
3880   LStartPos%=1
3890 ELSE
3900   LStartPos%=0
3910 END IF
3920 LIndex%=LStartPos%
3930 LMinPos%=LStartPos%
3940 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
3950 END DEFine LShowLeftDir
3960 REMark -----------------------------------------------------------------------
3970 DEFine PROCedure LShowRightDir
3980 LOCal i%
3990 DIM RightFiles$(MaxFiles%,_fMax%)
4000 RSizedir%=0: RSizeFile%=0
4010 LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
4020 IF LEN(rightDir$)=5 THEN
4030   RStartPos%=1
4040 ELSE
4050   RStartPos%=0
4060 END IF
4070 RIndex%=RStartPos%
4080 RMinPos%=RStartPos%
4090 ListFiles RightFiles$,RStartPos%,RIndex%,8
4100 END DEFine LShowRightDir
4110 REMark -----------------------------------------------------------------------
4120 REMark REFERENCE FileList$(0,0,0)
4130 REFERENCE FileList$(0,0)
4140 DEFine PROCedure ListFiles(FileList$, StartPos%, Index%, ch%)
4150 LOCal a$(linelen%), i%, size%, EndPos%, nochars%, x%, DFlen1%, DFLen2%
4160 IF ch%=7 THEN
4170   size%=LSizedir%+LSizeFile%
4180 ELSE
4190   size%=RSizedir%+RSizeFile%
4200 END IF
4210 EndPos%=StartPos%+rowno%-1
4220 IF EndPos%>size% THEN EndPos%=size%: END IF
4230 CLS#ch%
4240 FOR i%=StartPos% TO EndPos%
4250   a$=GetFNam$(FileList$,i%)
4260   DFlen1%=LEN(a$)
4270   DFLen2%=LEN(GetFLen(FileList$,i%))
4280   IF GetFFlg%(FileList$,i%) MOD 2 = 1 THEN
4290     x%=3
4300     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&'..':END IF
4310     a$=a$&' ->'
4320     a$=a$&FILL$(' ',linelen%-LEN(a$) - 1)
4330   ELSE
4340     x%=9
4350     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&'..':END IF
4360     a$=a$&FILL$(' ',linelen%-LEN(a$)-DFLen2% - 1)& GetFLen(FileList$,i%)
4370   END IF
4380   INK#ch%, ik%
4390   IF i%=Index% THEN
4400     IF crtPanel%=ch% THEN
4410       STRIP#ch%,strp%
4420       IF GetFFlg%(FileList$,i%) > 1 THEN INK#ch%,2 : ELSE INK#ch%,ppr% : END IF
4430       PRINT#ch%,a$
4440       STRIP#ch%,ppr%
4450     ELSE
4460       PRINT#ch%,a$
4470     END IF
4480   ELSE
4490     IF GetFFlg%(FileList$,i%) > 1 THEN INK#ch%,2 : ELSE INK#ch%,ik% : END IF
4500     PRINT#ch%,a$
4510   END IF
4520 END FOR i%
4530 END DEFine ListFiles
4540 REMark -----------------------------------------------------------------------
4550 DEFine PROCedure MainLoop
4560  LOCal a$, x%, y$
4570   REPeat loop
4580     a$=INKEY$(-1): x%=CODE(a$)
4590     SELect ON x%
4600       REMark CTRL-A
4610       =1  : MessageWnd 216,60,3, '        QL COMMANDER v'&qlcVer$&CHR$(10)&' Andrei Tenu & Martyn Hill - 2019'&CHR$(10)&'    GNU General Public License'
4620       REMark Down
4630       =216: IF crtPanel%=7 THEN
4640               MoveDown LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
4650             ELSE
4660               MoveDown RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
4670             END IF
4680       REMark Up
4690       =208: IF crtPanel%=7 THEN
4700               MoveUp LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
4710             ELSE
4720               MoveUp RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
4730             END IF
4740       REMark SHIFT-DOWN
4750       =220: IF crtPanel%=7 THEN
4760               MovePageDown LeftFiles$, LStartPos%, LIndex%, 7
4770             ELSE
4780               MovePageDown RightFiles$, RStartPos%, RIndex%, 8
4790             END IF
4800       REMark Tab
4810       =9  : ChangePanel
4820       REMark Shift-F5
4830       =250: RETurn
4840       REMark Space
4850       =32 : SelectFile
4860       REMark Shift-Up
4870       =212: IF crtPanel%=7 THEN
4880               MovePageUp LeftFiles$, LStartPos%, LIndex%, 7
4890             ELSE
4900               MovePageUp RightFiles$, RStartPos%, RIndex%, 8
4910             END IF
4920       REMark Enter
4930       =10 : OnEnter
4940       REMark Shift-Enter - LRUN BASIC file
4950       =254: LRUNBasic
4960       REMark CTRL-Left/Backspace
4970       =194
4980         IF crtPanel%=7 THEN
4990           MoveTop LeftFiles$, LStartPos%, LIndex%, 7
5000           IF GetFNam$(LeftFiles$,LIndex%)=".." THEN
5010             OnEnter
5020           ELSE
5030             BEEP 1390,20
5040           END IF
5050         ELSE
5060           MoveTop RightFiles$, RStartPos%, RIndex%, 8
5070           IF GetFNam$(RightFiles$,RIndex%)=".." THEN
5080             OnEnter
5090           ELSE
5100             BEEP 1390,20
5110           END IF
5120         END IF
5130       REMark CTRL-UP
5140       =210 :IF crtPanel%=7 THEN
5150               MoveTop LeftFiles$, LStartPos%, LIndex%, 7
5160             ELSE
5170               MoveTop RightFiles$, RStartPos%, RIndex%, 8
5180             END IF
5190       REMark CTRL-DOWN
5200       =218 :IF crtPanel%=7 THEN
5210               MoveLast LeftFiles$, LStartPos%, LIndex%, 7
5220             ELSE
5230               MoveLast RightFiles$, RStartPos%, RIndex%, 8
5240             END IF
5250       REMark Ctrl-D
5260       =4  : InputDir 5
5270       REMark Ctrl-R
5280       =18 : InputDir 6
5290       REMark F1
5300       =232 : ViewFile
5310       REMark F2
5320       =236 : CopyFiles
5330       REMark SHIFT-F1
5340       =234 : DoEdit
5350       REMark F3
5360       =240 : RenameFile
5370       REMark F4
5380       =244 : DeleteFiles
5390       REMark SHIFT-F2
5400       =238 : ShowInfo
5410       REMark F5
5420       =248 : CreateDir
5430       REMark Find next matching File/Dir starting with a$
5440       =65  TO  90: JumpTo x%, 1
5450       =160 TO 171: JumpTo x%, 1
5460       =97  TO 122: JumpTo x%, 2
5470       =128 TO 139: JumpTo x%, 2
5480       =48  TO  57: JumpTo x%, 0
5490       REMark + and =
5500       =43,61: SelectAll
5510       REMark - and _
5520       =45,95: UnSelectAll
5530       REMark SHIFT-F4
5540       =246: DrawWindows 0
5550       REMark SHIFT-F3
5560       =242: CompareDirs
5570       REMark CTRL-I
5580       =92: InvertSelection
5590     END SELect
5600   END REPeat loop
5610 END DEFine MainLoop
5620 REMark -----------------------------------------------------------------------
5630 DEFine FuNction FindFirst% (a%,what%)
5640  LOCal i%, istart%, iend%, found%
5650  REMark a% = code of char to find
5660  REMark what%=2 looking for file; =1 looking for dir; =0 looking for dir or file
5670  REMark search returns index of item that starts with a$, or first next item if a$ is not found, or last item in list if all existing items start with chars<a$
5680 found%=0
5690 IF crtPanel%=7 THEN
5700    IF what%<2 THEN istart%=1: ELSE istart%=LSizedir%+1: END IF
5710    IF what%=1 THEN iend%=LSizedir%: ELSE iend%=LSizedir%+LSizeFile%: END IF
5720    IF istart%>iend% THEN RETurn LIndex%: END IF
5730    IF what%>0 THEN
5740      FOR i%=istart% TO iend%
5750        IF CODE(GetFNam$(LeftFiles$,i%)) >= a% THEN found%=1: EXIT i%: END IF
5760        NEXT i%
5770      END FOR i%
5780    ELSE
5790      FOR i%=LIndex%+1 TO iend%
5800        IF CODE(GetFNam$(LeftFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
5810      NEXT i%: END FOR i%
5820      IF found%=0 THEN
5830        FOR i%=istart% TO LIndex%
5840          IF CODE(GetFNam$(LeftFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
5850        NEXT i%: END FOR i%
5860      END IF
5870      IF found%=0 THEN i%=istart%: END IF
5880    END IF
5890    IF i%<= iend% THEN RETurn i%: ELSE RETurn iend%: END IF
5900 ELSE
5910    IF what%<2 THEN istart%=1: ELSE istart%=RSizedir%+1:END IF
5920    IF what%=1 THEN iend%=RSizedir%: ELSE iend%=RSizedir%+RSizeFile%:END IF
5930    IF istart%>iend% THEN RETurn RIndex%: END IF
5940    IF what%>0 THEN
5950      FOR i%=istart% TO iend%
5960        IF CODE(GetFNam$(RightFiles$,i%)) >= a% THEN EXIT i%: END IF
5970        NEXT i%
5980      END FOR i%
5990    ELSE
6000      FOR i%=RIndex%+1 TO iend%
6010        IF CODE(GetFNam$(RightFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
6020      NEXT i%: END FOR i%
6030      IF found%=0 THEN
6040        FOR i%=istart% TO RIndex%
6050          IF CODE(GetFNam$(RightFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
6060        NEXT i%: END FOR i%
6070      END IF
6080      IF found%=0 THEN i%=istart%: END IF
6090    END IF
6100    IF i%<= iend% THEN RETurn i%: ELSE RETurn iend%: END IF
6110  END IF
6120 END DEFine FindFirst%
6130 REMark ---------------------------------
6140 DEFine PROCedure JumpTo (a%,what%)
6150 LOCal x%, start%
6160 IF crtPanel%=7 THEN
6170   IF LSizedir%+LSizeFile%=0 THEN RETurn : END IF
6180 ELSE
6190   IF RSizedir%+RSizeFile%=0 THEN RETurn : END IF
6200 END IF
6210 x%=FindFirst%(a%,what%)
6220 IF crtPanel%=7 THEN
6230   IF x%=LIndex% THEN RETurn : END IF
6240   IF (x%>=LStartPos%) AND (x%<LStartPos%+20) THEN
6250    ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
6260    LIndex%=x%
6270    ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
6280   ELSE
6290    LIndex%=x%
6300    x%=x%+(LMinPos%=0)
6310    page%=x% DIV rowno%
6320    IF x% MOD rowno% >0 THEN page%=page%+1: END IF
6330    LStartPos%=(page%-1)*rowno% +LMinPos%
6340    ListFiles LeftFiles$, LStartPos%, LIndex%, 7
6350   END IF
6360 ELSE
6370   IF x%=RIndex% THEN RETurn :END IF
6380   IF x%>=RStartPos% AND x%<RStartPos%+rowno% THEN
6390    ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
6400    RIndex%=x%
6410    ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
6420   ELSE
6430    RIndex%=x%
6440    x%=x%+(RMinPos%=0)
6450    page%=x% DIV rowno%
6460    IF x% MOD rowno% >0 THEN page%=page%+1: END IF
6470    RStartPos%=(page%-1)*rowno% +RMinPos%
6480    ListFiles RightFiles$, RStartPos%, RIndex%, 8
6490   END IF
6500 END IF
6510 END DEFine JumpTo
6520 REMark -----------------------------------------------------------------------
6530 REMark String Quick Search & Insert
6540 REMark (c)tcat, 2017 Tomas Kral
6550 REMark modified by Andrei Tenu 2018
6560 :
6570 REMark REFERENCE FileList$(0,0,0),id%
6580 REFERENCE FileList$(0,0),id%
6590 DEFine FuNction Find% (str$,id%,FileList$,no%,size%)
6600  REMark FileLis$ = name of array to load into
6610  REMark no% = start index
6620  REMark     = 0 if we add a dir to root; 1 if add a dir in a directory; SizeDir%+1 if we add a file
6630  REMark Quick search returns:
6640  REMark 0=not found, 1=found, id%=position
6650  LOCal top%,bot%,mid%,nextFNam$(maxFNLen%)
6660  top%=no% : bot%=size%
6670  :
6680  REPeat find_loop
6690   mid%=(bot%+top%) DIV 2 : nextFNam$=GetFNam$(FileList$,mid%)
6700   :
6710   IF top%>bot% THEN
6720    id%=mid%+1 : RETurn 0
6730   ELSE IF str$ = nextFNam$ THEN
6740    id%=mid% : RETurn 1
6750   ELSE IF str$ > nextFNam$ THEN
6760    top%=mid%+1
6770   ELSE IF str$ < nextFNam$ THEN
6780    bot%=mid%-1
6790   END IF : END IF : END IF : END IF
6800  END REPeat find_loop
6810 END DEFine Find%
6820 :
6830 REMark REFERENCE FileList$(0,0,0),r_SizeDir%, r_SizeFile%
6840 REFERENCE FileList$(0,0),r_SizeDir%, r_SizeFile%
6850 DEFine FuNction Insert% (str$,id%, FileList$, DoF%, r_SizeDir%, r_SizeFile%, fLength$)
6860  REMark Inserts String at position id%
6870  REMark Returns 2=ok, -1=array full
6880  LOCal i%, size%
6890  size%=r_SizeDir%+r_SizeFile%
6900  IF size% >= MaxFiles% THEN RETurn -1
6910  FOR i%=size% TO id% STEP -1
6920    CopyRec FileList$,i% TO FileList$,i%+1
6930  END FOR i%
6940  PutFNam FileList$,id%, str$
6950  PutFLen FileList$,id%, fLength$
6960  PutFFlg FileList$,id%, DoF%
6970  IF DoF%=1 THEN
6980    r_SizeDir%=r_SizeDir%+1
6990  ELSE
7000    r_SizeFile%=r_SizeFile%+1
7010  END IF
7020  :
7030  RETurn 2
7040 END DEFine Insert%
7050 REMark End of String Quick Search & Insert -----------------------------------
7060 :
7070 REMark -----------------------------------------------------------------------
7080 REMark REFERENCE dev$(0),FileList$(0,0,0),r_SizeDir%,r_SizeFile%
7090 REFERENCE dev$(0),FileList$(0,0),r_SizeDir%,r_SizeFile%
7100 DEFine PROCedure LoadDir (dev$, FileList$, Chan%, r_SizeDir%, r_SizeFile%)
7110  LOCal ch%, i, head_start, totrim, flength, file$, ftype, size2%, res, DirOrFile%, id%, filelen$,k$, no_files
7120  CLS#Chan%:INK#Chan%,7:PRINT#Chan%,'...Loading File List ...'
7130  IF dev$(LEN(dev$))<>'_' THEN dev$=dev$&'_'
7140  IF Chan%=7 THEN PRINT#5,dev$: ELSE PRINT#6, dev$: END IF
7150  IF DirExists%(dev$)=0 THEN
7160    BEEP 1390,100
7170    PRINT#Chan%, "Cannot open directory "&dev$
7180    RETurn
7190  END IF
7200  r_SizeDir%=0: r_SizeFile%=0
7210  totrim=LEN(dev$)-4
7220  IF totrim<=0 THEN totrim=1 : END IF
7230  :
7240  PutFNam FileList$,0, '..'
7250  PutFLen FileList$,0, 0
7260  PutFFlg FileList$,0, 1
7270  :
7280  head_start=0
7290  i=1
7300  ch%=FOP_DIR(dev$)
7310  no_files=FLEN(#ch%)/64
7320  FOR listing=1 TO no_files
7330    SET_POSITION #ch%,head_start+0
7340    flength=LONGINTEGER(INPUT$(#ch%,4))-64
7350    faccess=CODE(INKEY$(#ch%)):ftype=CODE(INKEY$(#ch%))
7360    IF flength>=0 THEN
7370      SET_POSITION #ch%,head_start+14
7380      file$=GET$(#ch%)
7390      IF LEN(file$)>0
7400       file$=file$(totrim TO)
7410       filelen$=flength
7420       SET_POSITION #ch%,head_start+52
7430       fdate=LONGINTEGER(INPUT$(#ch%,4))
7440       IF ftype<255
7450        size2%=r_SizeDir%+r_SizeFile%
7460        file$=LOWER$(file$)
7470        res=Find%(file$,id%, FileList$,r_SizeDir%+1,size2%)
7480        DirOrFile%=0
7490       ELSE
7500        file$=UPPER$(file$)
7510        res=Find%(file$,id%,FileList$,1,r_SizeDir%)
7520        DirOrFile%=1
7530       END IF
7540       i=i+1
7550    REMark k$='':
7560    REMark IF flength>1023 THEN
7570    REMark  flength=INT(flength/1024+.5):k$='K'
7580    REMark  IF flength>1023 THEN
7590    REMark    flength=INT(flength/1024+.5):k$='M'
7600    REMark  END IF
7610    REMark END IF
7620    REMark filelen$=flength&k$
7630       IF res=0 THEN res=Insert%(file$,id%,FileList$,DirOrFile%, r_SizeDir%, r_SizeFile%, filelen$) : END IF
7640       IF res=-1 : EXIT listing : END IF
7650      END IF
7660    END IF
7670    head_start=head_start+64
7680  END FOR listing
7690  CLOSE #ch%
7700 END DEFine LoadDir
7710 REMark -----------------------------------------------------------------------
7720 REMark REFERENCE FileList$(0,0,0),r_Index%,r_StartPos%
7730 REFERENCE FileList$(0,0),r_Index%,r_StartPos%
7740 DEFine PROCedure MoveDown(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
7750  LOCal size%, idx%
7760  size%=SizeFile%+SizeDir%
7770  IF r_Index%>size% THEN RETurn
7780  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 0
7790  r_Index%=r_Index%+1
7800  IF r_Index%>size% THEN : r_Index%=size%: END IF
7810  IF r_Index%>r_StartPos%+rowno%-1 THEN
7820    SCROLL#crtPanel%,-mainFountHeight%
7830    r_StartPos%=r_StartPos%+1
7840  END IF
7850  ShowHideCursor r_Index%-r_StartPos%, r_Index%,  FileList$, 1
7860 END DEFine MoveDown
7870 REMark -----------------------------------------------------------------------
7880 REMark REFERENCE FileList$(0,0,0),r_Index%,r_StartPos%
7890 REFERENCE FileList$(0,0),r_Index%,r_StartPos%
7900 DEFine PROCedure MoveUp(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
7910  LOCal size%, idx%
7920  size%=SizeFile%+SizeDir%
7930  IF r_Index%>size%  THEN RETurn
7940  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 0
7950  r_Index%=r_Index%-1
7960  IF r_Index%<MinPos% THEN : r_Index%=MinPos%: END IF
7970  IF r_Index%<r_StartPos% THEN
7980    SCROLL#crtPanel%,mainFountHeight%
7990    r_StartPos%=r_StartPos%-1
8000  END IF
8010  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 1
8020 END DEFine MoveDown
8030 REMark -----------------------------------------------------------------------
8040 REMark REFERENCE FileList$(0,0,0)
8050 REFERENCE FileList$(0,0)
8060 DEFine PROCedure ShowHideCursor(Linepos%, Index%, FileList$, SoH%)
8070 LOCal a$, x%, DFlen1%, DFLen2%
8080   :
8090   a$=GetFNam$(FileList$,Index%)
8100   DFlen1%=LEN(a$)
8110   DFLen2%=LEN(GetFLen(FileList$,Index%))
8120   :
8130   IF GetFFlg%(FileList$,Index%) MOD 2 = 1 THEN
8140     x%=3
8150     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&'..':END IF
8160     a$=a$&' ->'
8170     a$=a$&FILL$(' ',linelen%-LEN(a$) - 1)
8180   ELSE
8190     x%=9
8200     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&'..':END IF
8210     a$=a$&FILL$(' ',linelen%-LEN(a$)-DFLen2% - 1)& GetFLen(FileList$,Index%)
8220   END IF
8230   IF SoH%=1 THEN
8240     STRIP#crtPanel%,strp%: INK#crtPanel%,0
8250     IF GetFFlg%(FileList$,Index%) > 1 THEN INK#crtPanel%,2 : ELSE INK#crtPanel%,0 : END IF
8260     AT#crtPanel%,Linepos%,0:PRINT#crtPanel%,a$;
8270     STRIP#crtPanel%,ppr%:INK#crtPanel%,ik%
8280   ELSE
8290    IF GetFFlg%(FileList$,Index%) > 1 THEN INK#crtPanel%,2 : ELSE INK#crtPanel%,ik% : END IF
8300     AT#crtPanel%,Linepos%,0:PRINT#crtPanel%,a$;
8310   END IF
8320 END DEFine ShowHideCursor
8330 REMark -----------------------------------------------------------------------
8340 DEFine PROCedure ChangePanel
8350 IF crtPanel%=7 THEN
8360   IF LIndex%<=LSizedir%+LSizeFile% THEN
8370     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
8380   END IF
8390   crtPanel%=8
8400   IF RIndex%<=RSizedir%+RSizeFile% THEN
8410     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
8420   END IF
8430   BORDER#8,1,brd%: BORDER#7, 1,brd%,1,3
8440 ELSE
8450   IF RIndex%<=RSizedir%+RSizeFile% THEN
8460     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
8470   END IF
8480   crtPanel%=7
8490   IF LIndex%<=LSizedir%+LSizeFile% THEN
8500     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
8510   END IF
8520   BORDER#7,1,brd%: BORDER#8,1,brd%,1,3
8530 END IF
8540 END DEFine ChangePanel
8550 REMark -----------------------------------------------------------------------
8560 DEFine PROCedure SelectFile
8570   IF crtPanel%=7 THEN
8580     PutFFlg LeftFiles$,LIndex%,GetFFlg%(LeftFiles$,LIndex%) ^^2
8590     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
8600   ELSE
8610     PutFFlg RightFiles$,RIndex%,GetFFlg%(RightFiles$,RIndex%) ^^2
8620     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
8630   END IF
8640 END DEFine SelectFile
8650 REMark -----------------------------------------------------------------------
8660 REMark REFERENCE FileList$(0,0,0),r_StartPos%,r_Index%
8670 REFERENCE FileList$(0,0),r_StartPos%,r_Index%
8680 DEFine PROCedure MovePageDown(FileList$, r_StartPos%, r_Index%, ch%)
8690 LOCal size%, x%
8700  IF ch%=7 THEN
8710   size%=LSizedir%+LSizeFile%
8720  ELSE
8730   size%=RSizedir%+RSizeFile%
8740  END IF
8750  IF r_Index%>size% THEN RETurn : END IF
8760  x%=r_StartPos%+20
8770  IF x%>size% THEN RETurn
8780  r_StartPos%=x%
8790  r_Index%=r_StartPos%
8800  ListFiles FileList$, r_StartPos%, r_Index%, ch%
8810 END DEFine MovePageDown
8820 REMark -----------------------------------------------------------------------
8830 REMark REFERENCE FileList$(0,0,0),r_StartPos%,r_Index%
8840 REFERENCE FileList$(0,0),r_StartPos%,r_Index%
8850 DEFine PROCedure MovePageUp(FileList$, r_StartPos%, r_Index%, ch%)
8860 LOCal top%, x%, size%
8870  IF ch%=7 THEN
8880   top%= LMinPos%
8890   size%=LSizeFile%+LSizedir%
8900  ELSE
8910   top%=RMinPos%
8920   size%=RSizeFile%+RSizedir%
8930  END IF
8940  IF r_Index%>size% THEN RETurn : END IF
8950  x%=r_StartPos%-20
8960  IF x%<top% THEN x%=top%:END IF
8970  r_StartPos%=x%
8980  r_Index%=r_StartPos%
8990  ListFiles FileList$, r_StartPos%, r_Index%, ch%
9000 END DEFine MovePageUp
9010 REMark -----------------------------------------------------------------------
9020 REMark REFERENCE FileList$(0,0,0)
9030 REFERENCE FileList$(0,0)
9040 DEFine PROCedure OpenSubDir(FileList$, Index%, ch%)
9050 LOCal a$, size%, d$, x%, page%
9060 IF ch%=7 THEN
9070  size%=LSizeFile%+LSizedir%
9080  d$=leftDir$
9090 ELSE
9100  size%=RSizeFile%+RSizedir%
9110  d$=rightDir$
9120 END IF
9130 IF Index%>size% THEN RETurn : END IF
9140 IF GetFFlg%(FileList$,Index%) MOD 2 <> 1 THEN RETurn : END IF
9150 IF GetFNam$(FileList$,Index%)='..' THEN
9160   a$=GetParentDir$(ch%)
9170   IF LEN(d$)>LEN(a$) THEN
9180     d$=d$(LEN(a$)+1 TO): IF d$(LEN(d$))='_' THEN d$=d$(1 TO LEN(d$)-1):END IF
9190     IF crtPanel%=7 THEN
9200       DIM LeftFiles$(MaxFiles%,_fMax%) : leftDir$=a$
9210       LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
9220       IF LEN(leftDir$)=5 THEN
9230         LMinPos%=1
9240       ELSE
9250         LMinPos%=0
9260       END IF
9270       IF Find%(d$,id%, LeftFiles$,1,LSizedir%)=1 THEN
9280         LIndex%=id%
9290         x%=id%+(LMinPos%=0)
9300         page%=x% DIV rowno%
9310         IF x% MOD rowno% >0 THEN page%=page%+1: END IF
9320         LStartPos%=(page%-1)*rowno% +LMinPos%
9330         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
9340       ELSE
9350        d$=''
9360       END IF
9370     ELSE
9380       DIM RightFiles$(MaxFiles%,_fMax%) : rightDir$=a$
9390       LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
9400       IF LEN(rightDir$)=5 THEN
9410         RMinPos%=1
9420       ELSE
9430         RMinPos%=0
9440       END IF
9450       IF Find%(d$,id%, RightFiles$,1,RSizedir%)=1 THEN
9460         RIndex%=id%
9470         x%=id%+(RMinPos%=0)
9480         page%=x% DIV rowno%
9490         IF x% MOD rowno% >0 THEN page%=page%+1: END IF
9500         RStartPos%=(page%-1)*rowno% +RMinPos%
9510         ListFiles RightFiles$, RStartPos%, RIndex%, 8
9520       ELSE
9530          d$=''
9540       END IF
9550     END IF
9560   ELSE
9570     d$=''
9580   END IF
9590 ELSE
9600   d$=''
9610   IF ch%=7 THEN
9620     a$=leftDir$& GetFNam$(FileList$,Index%)
9630   ELSE
9640     a$=rightDir$& GetFNam$(FileList$,Index%)
9650   END IF
9660 END IF
9670 IF LEN(d$)=0 THEN
9680   IF ch%=7 THEN
9690     leftDir$=a$
9700     LShowLeftDir
9710   ELSE
9720     rightDir$=a$
9730     LShowRightDir
9740   END IF
9750 END IF
9760 END DEFine OpenSubDir
9770 REMark -----------------------------------------------------------------------
9780 DEFine FuNction GetParentDir$(ch%)
9790 LOCal i%, dir$
9800 IF ch%=7 THEN dir$=leftDir$: ELSE dir$=rightDir$:END IF
9810 FOR i% = LEN(dir$)-1 TO 5 STEP -1
9820  IF dir$(i%) = "_" THEN
9830    IF FTEST(dir$(1 TO i%)) = 0 THEN
9840      IF FTYP(\dir$(1 TO i%)) = 255 THEN EXIT i%
9850    END IF
9860  END IF
9870 END FOR i%
9880 dir$ = dir$(1 TO i%)
9890 RETurn dir$
9900 END DEFine GetParentDir$
9910 REMark -----------------------------------------------------------------------
9920 DEFine PROCedure InputDir(ch%)
9930  LOCal a$, olddir$
9940  PAPER#ch%,0:INK#ch%,7:CLS#ch%
9950  IF ch%=5 THEN
9960    olddir$=leftDir$
9970  ELSE
9980    olddir$=rightDir$
9990  END IF
10000  a$=EDIT$(#ch%, olddir$, 36): CLS#ch%
10010  PAPER#ch%,White%:INK#ch%,0:CLS#ch%
10020  IF a$='' THEN a$=olddir$
10030  IF a$(LEN(a$))<>'_' THEN a$=a$&'_'
10040  IF DirExists%(a$) = 0 THEN
10050    BEEP 1390,20:PRINT#ch%, olddir$
10060    RETurn
10070  END IF
10080  IF ch%=5 THEN
10090    IF crtPanel%=8 THEN ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0: END IF
10100    leftDir$=a$
10110    crtPanel%=7
10120    LShowLeftDir
10130    BORDER#7,1,brd%: BORDER#8,1,brd%,1,3
10140  ELSE
10150    IF crtPanel%=7 THEN ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0: END IF
10160    rightDir$=a$
10170    crtPanel%=8
10180    LShowRightDir
10190    BORDER#8,1,brd%: BORDER#7, 1,brd%,1,3
10200  END IF
10210 END DEFine InputDir
10220 REMark -----------------------------------------------------------------------
10230 DEFine PROCedure ViewFile
10240  LOCal ext$(10), a$, x%, i%, ch%, ch1%, ch2%, ch3%, left%, windef$, wid%,hgt%,top%
10250  IF crtPanel%=7 THEN
10260    IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
10270    a$=GetFNam$(LeftFiles$,LIndex%)
10280  ELSE
10290    IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
10300    a$=GetFNam$(RightFiles$,RIndex%)
10310  END IF
10320  IF a$=='..' OR a$=='<un-named>' OR IsDir%=1 THEN RETurn : END IF
10330  REMark now get file extension
10340  x%=LEN(a$)
10350  FOR i%=0 TO x%-1
10360    IF a$(x%-i%)=='_' OR a$(x%-i%)=='.' THEN EXIT i%
10370  END FOR i%
10380  IF i%>0 THEN
10390    ext$=a$(x%-i%+1 TO x%)
10400  ELSE
10410    ext$=''
10420  END IF
10430  IF crtPanel%=7 THEN
10440    a$=leftDir$&a$
10450  ELSE
10460    a$=rightDir$&a$
10470  END IF
10480  ext$=LOWER$(ext$) : x%=0
10490  IF ext$='fnt' THEN x%=1: END IF
10500  IF ext$='fat' THEN x%=2: END IF
10510  IF ext$='scr' THEN x%=3: END IF
10520  IF ext$='doc' THEN x%=4: END IF
10530  IF ext$='zip' THEN x%=5: END IF
10540  IF x%<>3 THEN
10550    IF x%=1 OR x%=2 THEN
10560      left%=(maxWinWid%-448) DIV 2 - 2
10570      wid%=452:hgt%=230: top%=(panelWinHeight%+2*mainFountHeight%+7-hgt%) DIV 2 + 14
10580      windef$="scr_452x230a"&left%&"x"&top%
10590      ch%=FOPEN(windef$)
10600      PAPER #ch%,0:INK #ch%,White%
10610      OUTLN #ch%,452,230,left%,top%:BORDER#ch%,1,2:CLS#ch%
10620      windef$="scr_452x12a"&left%&"x"&top%
10630      ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
10640      PAPER#ch1%,0: INK#ch1%,White%: AT#ch1%,0,37-(LEN(a$)+5)/2: PRINT#ch1%, 'View '&a$
10650      left%=left%+2: windef$="scr_448x204a"&left%&"x"&(top%+12)
10660      ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
10670    ELSE
10680      IF maxWinWid%>600 THEN wid%=600: ELSE wid%=452: END IF
10690      hgt%=panelWinHeight%+27
10700      left%=(maxWinWid%-wid%) DIV 2 - 2
10710      top%=mainFountHeight%+4
10720      windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x"&top%
10730      ch%=FOPEN(windef$)
10740      PAPER #ch%,0:INK #ch%,White%
10750      OUTLN #ch%,wid%,hgt%,left%,top%:BORDER#ch%,1,2:CLS#ch%
10760      windef$="scr_"&wid%&"x12a"&left%&"x"&top%
10770      ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
10780      PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-(LEN(a$)+5)*6)DIV 2,0: PRINT#ch1%, 'View '&a$
10790      left%=left%+2: windef$="scr_"&(wid%-4)&"x"&(hgt%-26)&"a"&left%&"x"&(top%+12)
10800      ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
10810    END IF
10820  END IF
10830  SELect ON x%
10840    = 1: ViewFont a$, 1, ch2%
10850    = 2: ViewFont a$, 2, ch2%
10860    = 3: ViewImage a$, 4: Set78CharSet
10870    = 4: WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
10880        IF IsQuillDoc%(a$)=1 THEN
10890          IF FTEST(ConfigDrv$&'quill_view') =0 THEN
10900            EW ConfigDrv$&'quill_view', #ch2%; '-t '&a$&' '&TempDir$&'quill_tmp'
10910              IF FTEST(TempDir$&'quill_tmp') =0 THEN
10920              IF mainFountBase>0 AND wid%<600 THEN :CHAR_USE#ch2%,mainFountBase,0: CHAR_INC #ch2%,5,10: END IF
10930              MORE#ch2%, TempDir$&'quill_tmp'
10940              DELETE TempDir$&'quill_tmp'
10950            END IF
10960          ELSE
10970            PRINT #ch2%,'Cannot find quill_view'
10980          END IF
10990        ELSE
11000          MORE#ch2%, a$
11010        END IF
11020    =5: WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
11030       IF IsZipFile%(a$)=1 THEN
11040         IF FTEST(ConfigDrv$&'unzip')=0 THEN
11050           ch3%=FOP_OVER (TempDir$&'zip_tmp')
11060           IF ch3%>0 THEN
11070             EW ConfigDrv$&'unzip',#ch3%,#ch3%,#ch3%;'-lqq '&a$
11080             CLOSE#ch3%
11090             MORE#ch2%, TempDir$&'zip_tmp'
11100             DELETE TempDir$&'zip_tmp'
11110           ELSE
11120             PRINT #ch2%,'Cannot create temporary file'
11130           END IF
11140         ELSE
11150            PRINT #ch2%,'Cannot find unzip'
11160         END IF
11170       ELSE
11180         MORE#ch2%, a$
11190       END IF
11200    = REMAINDER :
11210      WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
11220      MORE#ch2%, a$
11230  END SELect
11240  IF x%<>3 THEN
11250    CHAR_USE#ch2%,0,0
11260    CLS#ch1%: CLS#ch2%: CLOSE#ch2%:CLOSE#ch1%
11270    WINDOW#0,488,23,12,233:PAPER#0,0:INK#0,White%
11280    OUTLN #ch%,wid%,hgt%,left%,top%
11290    CLOSE#ch%
11300  END IF
11310 END DEFine ViewFile
11320 REMark -----------------------------------------------------------------------
11330 DEFine PROCedure ViewFont (file$, type%, ch%)
11340 LOCal lng, i, base, type$(6)
11350 lng=FLEN(\file$)
11360 IF lng>0 THEN
11370  AT#ch%,0,0:PRINT#ch%, 'Font: '&file$; '      ';
11380  AT#ch%,0,44:PRINT#ch%, 'Font size = ';lng;' bytes'
11390 ELSE
11400  PRINT#ch%, 'Font NOT FOUND' : RETurn
11410 END IF
11420 base = ALCHP(lng)
11430 LBYTES file$,base
11440 :
11450 IF type%=1 THEN type%=TestFount%(base)
11460 IF type%=1 THEN type$="(5x9)" : ELSE type$="(8x9)"
11470 AT #ch%,0,7 + LEN(file$) : PRINT #ch%,type$;
11480 :
11490 AT#ch%,1,0:PRINT#ch%, 'Lowest character code = '; PEEK(base); '        ';
11500 AT#ch%,1,44:PRINT#ch%, 'Number of characters  = '; PEEK(base+1) + 1
11510 PRINT#ch%,'  '
11520 CHAR_USE#ch%,base,0
11530 CSIZE #ch%, (type%=2),0: CHAR_INC#ch%,6 + 2*(type%=2),10
11540 FOR i=0 TO 9
11550   PRINT#ch%,CHR$(i);
11560 NEXT i: END FOR i
11570 PRINT#ch%,' ';
11580 FOR i=11 TO 255:PRINT#ch%,CHR$(i);:NEXT i: END FOR i
11590 PRINT#ch%,CHR$(10)
11600 PRINT#ch%, 'The quick brown fox jumped over the lazy dog'
11610 CSIZE#ch%, 2+(type%=2),0 : CHAR_INC#ch%,12 + 4*(type%=2),10
11620 PRINT#ch%, 'The quick brown fox jumped over the lazy dog'
11630 CSIZE#ch%, 2+(type%=2),1 : CHAR_INC#ch%,12 + 4*(type%=2),20
11640 PRINT#ch%, 'The quick brown fox jumped over the lazy dog'
11650 CHAR_USE#ch%,0,0
11660 RECHP base
11670 xx$=INKEY$(-1)
11680 END DEFine ViewFont
11690 REMark -----------------------------------------------------------------------
11700 DEFine PROCedure MessageWnd(width%, height%, type%, text$)
11710 LOCal ch%, k$, AtX%,AtY%
11720 AtX%=(maxWinWid% - width%)/2
11730 AtY%=(256-height%)/2
11740 ch% = FOPEN('con')
11750 OUTLN#ch%; width%-2, height%, AtX%, AtY%, 4, 3
11760 SELect ON type%
11770   =1:
11780   PAPER#ch%,Green%:INK#ch%,0:CLS#ch%
11790   BLOCK#ch%,width%-4, 8, 1, 1,Green%,1,1
11800   AT#ch%, 1,1: PRINT#ch%, text$
11810   =2:
11820   PAPER#ch%,2:INK#ch%,White%:CLS#ch%
11830   BLOCK#ch%,width%-4, 8, 1, 1,2,1,1
11840   CURSOR#ch%,(width%-49)/2,1:PRINT#ch%,' ERROR '
11850   AT#ch%, 1,1: PRINT#ch%, text$
11860   =3:
11870   PAPER#ch%,White%:INK#ch%,0:BORDER#ch%,1,2::CLS#ch%
11880   BLOCK#ch%,width%-8, 8, 1, 1,2,0,1
11890   CURSOR#ch%,(width%-49)/2,1:PRINT#ch%,' ABOUT '
11900   CURSOR#ch%,2,15:PRINT#ch%, text$
11910 END SELect
11920 CURSOR#ch%,(width%-130)/2,48:PRINT#ch%,'... press any key ...'
11930 k$=INKEY$(-1)
11940 OUTLN#ch%; width%, height%, AtX%, AtY%
11950 CLOSE#ch%
11960 END DEFine MessageWnd
11970 REMark -----------------------------------------------------------------------
11980 DEFine FuNction IsDir%
11990 LOCal k%, lenghth, bufsize
12000 IF crtPanel%=7 THEN
12010   k%=GetFFlg%(LeftFiles$,LIndex%) MOD 2
12020 ELSE
12030   k%=GetFFlg%(RightFiles$,RIndex%) MOD 2
12040 END IF
12050 RETurn k%
12060 END DEFine IsDir%
12070 REMark -----------------------------------------------------------------------
12080 DEFine PROCedure ViewImage(a$, mode%)
12090 LOCal ch%, ch1%,scrSz,scrBuf,maxScrSz
12100   IF maxWinHgt%>256 OR maxWinWid%>512 OR RMODE>8 THEN
12110     MessageWnd 200,60,2, CHR$(10)&' _scr images can only be viewed'&CHR$(10)&'  on classic QL configuration':RETurn
12120   END IF
12130   maxScrSz=32768
12140   scrSz=FLEN(\a$)
12150   IF scrSz > maxScrSz THEN
12160     scrBuf=ALCHP(scrSz) : IF scrBuf<0 THEN BEEP 1390,10 : RETurn
12170     LBYTES a$,scrBuf : a$=TempDir$ & "tmp_scr"
12180     SBYTES_O a$, scrBuf, maxScrSz
12190     RECHP scrBuf
12200   END IF
12210   ch% = FOPEN('con')
12220   OUTLN#ch%; 512, 256, 0, 0
12230   IF mode%=4 THEN MODE 4: ELSE MODE 8: END IF
12240   LBYTES a$, 131072 : PAUSE 10
12250   k%=CODE(INKEY$(-1))
12260   SELect ON k%
12270     = 52: OUTLN#ch%; 512, 256, 0, 0: CLOSE#ch%: ViewImage a$, 4
12280     = 56: OUTLN#ch%; 512, 256, 0, 0: CLOSE#ch%: ViewImage a$, 8
12290     = REMAINDER : MODE 4
12300       OUTLN#ch%; 512, 256, 0, 0
12310       CLOSE#ch%
12320       DELETE TempDir$ & "tmp_scr"
12330   END SELect
12340 END DEFine ViewImage
12350 REMark -----------------------------------------------------------------------
12360 DEFine FuNction InputWnd$(width%, height%, title$, text$,default$)
12370 LOCal ch%, ch1%, k$, AtX%,AtY%
12380 AtX%=(maxWinWid% -width%)/2
12390 AtY%=(256-height%)/2
12400 ch% = FOPEN('con')
12410 OUTLN#ch%; width%, height%, AtX%, AtY%, 4, 3
12420 BORDER#ch%,1,4
12430 PAPER#ch%,White%:INK#ch%,0:CLS#ch%
12440 BLOCK#ch%,width%-4, 10, 0, 0,Green%,1,1
12450 PAPER#ch%,Green%:INK#ch%,0:CURSOR#ch%,(width%-6-LEN(title$)*6)/2,0:PRINT#ch%,title$
12460 PAPER#ch%,White%: INK#ch%,0:CURSOR#ch%, 6,16: PRINT#ch%, text$
12470 CURSOR#ch%,(width%-198)/2,48:PRINT#ch%,'... leave it empty to cancel ...'
12480 ch1% = FOPEN('con')
12490 WINDOW #ch1%, width%-18,12,AtX%+8, AtY%+28
12500 PAPER#ch1%,0:INK#ch1%,White%:CLS#ch1%
12510 k$=EDIT$(#ch1%,default$, 36)
12520 CLOSE#ch1%
12530 OUTLN#ch%; width%, height%, AtX%, AtY%
12540 CLOSE#ch%
12550 RETurn k$
12560 END DEFine InputWnd$
12570 REMark -----------------------------------------------------------------------
12580 DEFine FuNction DirExists% (name$)
12590 LOCal er%, ch%, d$, dname$
12600 dname$=name$
12610 IF dname$(LEN(dname$))<>'_' THEN dname$=dname$&'_': END IF
12620 IF LEN(dname$)=5 THEN
12630   d$=DATAD$: DATA_USE CHR$(0)
12640   ch%=FOP_DIR(dname$)
12650   DATA_USE d$
12660   IF ch%<0 THEN
12670     er%=0
12680   ELSE
12690     CLOSE#ch%
12700     er%=1
12710   END IF
12720 ELSE
12730   IF FTEST(dname$) = 0 THEN
12740     IF FTYP(\dname$) = 255 THEN er% = 1 : ELSE er% = 0 : END IF
12750   ELSE
12760     er% = 0
12770   END IF
12780 END IF
12790 RETurn er%
12800 END DEFine DirExists%
12810 REMark -----------------------------------------------------------------------
12820 DEFine PROCedure CreateDir
12830 LOCal x%,DirName$, FullDirName$
12840 DirName$=InputWnd$(240,60,' Create Directory ', 'Directory Name:','')
12850 DirName$=UPPER$(DirName$)
12860 IF DirName$='' THEN RETurn : END IF
12870 IF crtPanel%=7 THEN
12880   FullDirName$=leftDir$&DirName$
12890 ELSE
12900   FullDirName$=rightDir$&DirName$
12910 END IF
12920 x%=Create1Dir% (DirName$, FullDirName$, crtPanel%, 1,1,1)
12930 END DEFine CreateDir
12940 REMark -----------------------------------------------------------------------
12950 DEFine FuNction Create1Dir%(DirName$, FullDirName$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
12960 LOCal res%, fres%, page%, msg$
12970 IF LEN(FullDirName$)>41 THEN
12980   IF UpdateWnd%=1 THEN
12990     MessageWnd 200,60,2, CHR$(10)&'          Name too long !'
13000     RETurn 0
13010   ELSE
13020     INK#0,2:PRINT#0,'Directory not created  Name too long':INK#0,White%:RETurn 0
13030   END IF
13040 END IF
13050 IF (Qubide%=1) AND (CheckNoQ%=1) THEN
13060   IF TestQubideRestriction%(DirName$, panel%)=1 THEN
13070     IF UpdateWnd%=1 THEN
13080       MessageWnd 200,60,2, '   Cannot create Directory !'&CHR$(10)&'  QUBIDE limitation: Files will'&CHR$(10)&'     fall in the directory !'
13090       RETurn 0
13100     ELSE
13110       INK#0,2:PRINT#0,'Directory not created QUBIDE limitation: Files will fall in the directory':INK#0,White%:RETurn 0
13120     END IF
13130   END IF
13140 END IF
13150 IF DirName$(LEN(DirName$))='_' THEN DirName$=DirName$(1 TO LEN(DirName$)-1):END IF
13160 IF panel%=7 THEN
13170    IF (CheckNoQ%=1) AND (LSizedir%+LSizeFile%+1>=MaxFiles%) THEN
13180      IF UpdateWnd%=1 THEN
13190        MessageWnd 200,60,2, CHR$(10)&'   Cannot create Directory !'&CHR$(10)&CHR$(10)&'     maximum number reached !'
13200        RETurn 0
13210      ELSE
13220        INK#0,2:PRINT#0,'Directory not created. You have reached the maximum number of files and directories':INK#0,White%:RETurn -1
13230      END IF
13240    ELSE
13250      fres%=FMAKE_DIR (FullDirName$)
13260      IF (UpdateList%=1) AND (fres%>=0) THEN
13270        res%=Find% (DirName$,id%,LeftFiles$,1,LSizedir%)
13280        IF res%=0 THEN res%=Insert% (DirName$,id%, LeftFiles$, 1, LSizedir%, LSizeFile%, '0'):END IF
13290        LIndex%=id%
13300        IF UpdateWnd%=1 THEN
13310          id%=id%+(LMinPos%=0)
13320          page%=id% DIV rowno%
13330          IF id% MOD rowno% >0 THEN page%=page%+1: END IF
13340          LStartPos%=(page%-1)*rowno% +LMinPos%
13350          ListFiles LeftFiles$, LStartPos%, LIndex%, 7
13360        END IF
13370        RETurn 1
13380      ELSE
13390        IF fres%>=0 THEN RETurn 1
13400      END IF
13410    END IF
13420 ELSE
13430    IF (CheckNoQ%=1) AND (RSizedir%+RSizeFile%+1>=MaxFiles%) THEN
13440      IF UpdateWnd%=1 THEN
13450        MessageWnd 200,60,2, CHR$(10)&'   Cannot create Directory !'&CHR$(10)&CHR$(10)&'     maximum number reached !'
13460        RETurn 0
13470      ELSE
13480        INK#0,2:PRINT#0,'Directory not created. You have reached the maximum number of files and directories':INK#0,White%:RETurn -1
13490      END IF
13500    ELSE
13510      fres%=FMAKE_DIR (FullDirName$)
13520      IF (UpdateList%=1) AND (fres%>=0) THEN
13530        res%=Find% (DirName$,id%,RightFiles$,1,RSizedir%)
13540        IF res%=0 THEN res%=Insert% (DirName$,id%, RightFiles$, 1, RSizedir%, RSizeFile%, '0'): END IF
13550        RIndex%=id%
13560        IF UpdateWnd%=1 THEN
13570          id%=id%+(RMinPos%=0)
13580          page%=id% DIV rowno%
13590          IF id% MOD rowno% >0 THEN page%=page%+1: END IF
13600          RStartPos%=(page%-1)*rowno% +RMinPos%
13610          ListFiles RightFiles$, RStartPos%, RIndex%, 8
13620        END IF
13630        RETurn 1
13640      ELSE
13650        IF fres%>=0 THEN RETurn 1
13660      END IF
13670    END IF
13680 END IF
13690 SELect ON fres%
13700   =-8, -9: msg$= '   Cannot create Directory !'&CHR$(10)&'    A file or a directory with'&CHR$(10)&'    same name already exists !'
13710   =-11:msg$= CHR$(10)&'    Cannot create Directory'&CHR$(10)&'            Drive full'
13720   =-15:msg$= CHR$(10)&'    Cannot create Directory'&CHR$(10)&'       Drive is not Level2'
13730   =-19:msg$= CHR$(10)&'    Cannot create Directory'&CHR$(10)&'       Not implemented yet'
13740   =-20:msg$= CHR$(10)&'    Cannot create Directory'&CHR$(10)&'        Drive is Read Only '
13750   =REMAINDER :msg$= CHR$(10)&'    Cannot create Directory'&CHR$(10)&'            Error '&fres%
13760 END SELect
13770 IF UpdateWnd%=1 THEN
13780   MessageWnd 200,60,2, msg$
13790   IF (fres%=-15) OR (fres%=-19) THEN DELETE FullDirName$: END IF
13800   RETurn 0
13810 ELSE
13820   SELect ON fres%
13830     =-8, -9: INK#0,2:PRINT#0,'Directory not created  A file or a directory with same name already exists':INK#0,White%:RETurn 0
13840     REMark =-9:ink#0,2:print#0,'Directory not created  A directory with same name already exists':INK#0,White%:Return 0
13850      =-11:INK#0,2:PRINT#0,'Directory not created Drive full':INK#0,White%:RETurn -1
13860      =-15:INK#0,2:PRINT#0,'Directory not created  Drive is not Level2':INK#0,White%:RETurn -1
13870      =-19:INK#0,2:PRINT#0,'Directory not created  Operation not implemented yet for this drive type':INK#0,White%:RETurn -1
13880      =-20:INK#0,2:PRINT#0,'Directory not created  Drive is Read Only ':INK#0,White%:RETurn -1
13890      =REMAINDER : INK#0,2:PRINT#0,'Directory not created  Error '&fres%:INK#0,White%:RETurn 0
13900   END SELect
13910 END IF
13920 END DEFine Create1Dir%
13930 REMark -----------------------------------------------------------------------
13940 DEFine FuNction CountSelected%
13950 LOCal i%, counter%
13960 counter%=0
13970 IF crtPanel%=7 THEN
13980   FOR i%=1 TO LSizedir%+LSizeFile%
13990     IF GetFFlg%(LeftFiles$,i%) > 1 THEN counter%=counter%+1 : END IF
14000   END FOR i%
14010 ELSE
14020   FOR i%=1 TO RSizedir%+RSizeFile%
14030     IF GetFFlg%(RightFiles$,i%) > 1 THEN counter%=counter%+1 : END IF
14040   END FOR i%
14050 END IF
14060 RETurn counter%
14070 END DEFine CountSelected%
14080 REMark -----------------------------------------------------------------------
14090 DEFine FuNction DlgWnd%(width%, height%, title$, text$)
14100 LOCal ch%, a$, k%, AtX%, AtY%, loopa
14110 AtX%=(maxWinWid%-width%)/2
14120 AtY%=(256-height%)/2
14130 ch% = FOPEN('con')
14140 OUTLN#ch%; width%, height%, AtX%, AtY%, 4, 3
14150 BORDER#ch%,1,Green%
14160 PAPER#ch%,White%:INK#ch%,0:CLS#ch%
14170 BLOCK#ch%,width%-4, 10, 0, 0,Green%,1,1
14180 PAPER#ch%,Green%:INK#ch%,0:CURSOR#ch%,(width%-6-LEN(title$)*6)/2,0:PRINT#ch%,title$
14190 PAPER#ch%,White%: INK#ch%,0:CURSOR#ch%, 6,16: PRINT#ch%, text$
14200 CURSOR#ch%,(width%-198)/2,48:
14210 INK#ch%,2: PRINT#ch%,'    C';:INK#ch%,0:PRINT#ch%,'ancel                ';
14220 INK#ch%,2: PRINT#ch%,'O';:INK#ch%,0:PRINT#ch%,'k'
14230 REPeat loopa
14240    a$=INKEY$(-1)
14250    IF a$ INSTR 'oO'&CHR$(10) THEN k%=1: EXIT loopa: END IF
14260    IF a$ INSTR 'cC'&CHR$(27) THEN k%=0: EXIT loopa: END IF
14270 END REPeat loopa
14280 OUTLN#ch%; width%, height%, AtX%, AtY%
14290 CLOSE#ch%
14300 RETurn k%
14310 END DEFine DlgWnd%
14320 REMark -----------------------------------------------------------------------
14330 DEFine FuNction TestQubideRestriction%(DirName$, panel%)
14340 LOCal i%, name$
14350 name$=DirName$
14360 IF name$(LEN(name$))<>'_' THEN name$=name$&'_'
14370 IF panel%=7 THEN
14380   FOR i%=LSizedir%+1 TO LSizedir%+LSizeFile%
14390     IF name$ INSTR LeftFiles$(i%) = 1 THEN RETurn 1 : END IF
14400   END FOR i%
14410 ELSE
14420   FOR i%=RSizedir%+1 TO RSizedir%+RSizeFile%
14430     IF name$ INSTR RightFiles$(i%) = 1 THEN RETurn 1 : END IF
14440   END FOR i%
14450 END IF
14460 RETurn 0
14470 END DEFine TestQubideRestriction%
14480 REMark -----------------------------------------------------------------------
14490 DEFine FuNction IsQuillDoc%(a$)
14500 LOCal ch%, q$, i%, k%
14510 ch% = FOPEN(a$)
14520 IF ch% <= 0 THEN RETurn 0: END IF
14530 q$=''
14540 BGET #ch%\1,k%
14550 FOR i%=1 TO 8
14560  BGET #ch%,k%
14570  q$=q$&CHR$(k%)
14580 NEXT i%: END FOR i%
14590 CLOSE #ch%
14600 IF q$='vrm1qdf0' THEN RETurn 1: ELSE RETurn 0: END IF
14610 END DEFine IsQuillDoc%
14620 REMark -----------------------------------------------------------------------
14630 DEFine FuNction IsZipFile%(a$)
14640 LOCal ch%, q$, i%, k%
14650 ch% = FOPEN(a$)
14660 IF ch% <= 0 THEN RETurn 0: END IF
14670 q$=''
14680 FOR i%=1 TO 4
14690  BGET #ch%,k%
14700  q$=q$&CHR$(k%)
14710 NEXT i%: END FOR i%
14720 CLOSE #ch%
14730 IF q$='PK'&CHR$(3)&CHR$(4) THEN RETurn 1: ELSE RETurn 0: END IF
14740 END DEFine IsZipFile%
14750 REMark -----------------------------------------------------------------------
14760 DEFine PROCedure RenameFile
14770 LOCal NewFileName$,filename$, sourcepath$, res%, i%, x%, filelen$, page%
14780 IF crtPanel%=7 THEN
14790  IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
14800 ELSE
14810  IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
14820 END IF
14830 IF crtPanel%=7 THEN
14840    filename$=GetFNam$(LeftFiles$,LIndex%)
14850    sourcepath$=leftDir$
14860 ELSE
14870    filename$=GetFNam$(RightFiles$,RIndex%)
14880    sourcepath$=rightDir$
14890 END IF
14900 IF filename$='..' THEN RETurn : END IF
14910 IF IsDir%=1 THEN
14920   MessageWnd 200,60,2, CHR$(10)&'   Cannot rename a Directory!'
14930   RETurn
14940 END IF
14950 res%=FTEST(sourcepath$&filename$)
14960 IF res%=-9 THEN
14970   MessageWnd 200,60,2, CHR$(10)&'   File in Use! Cannot rename!'
14980   RETurn
14990 END IF
15000 IF res%=-20 THEN
15010   MessageWnd 200,60,2, CHR$(10)&'       File is Read Only! '&CHR$(10)&'          Cannot rename!'
15020   RETurn
15030 END IF
15040 NewFileName$=InputWnd$(240,60,' Rename File ', 'Rename '&filename$&' to:',filename$)
15050 IF NewFileName$='' THEN RETurn : END IF
15060 IF LEN(sourcepath$&NewFileName$)>36 THEN
15070   MessageWnd 200,60,2, CHR$(10)&'   Full file name is too long!'
15080   RETurn
15090 END IF
15100 IF FTEST(sourcepath$&NewFileName$)<>-7 THEN
15110   MessageWnd 200,60,2, CHR$(10)&'      A file with this name'&CHR$(10)&'          already exists!'
15120   RETurn
15130 END IF
15140 RENAME sourcepath$&filename$ TO sourcepath$&NewFileName$
15150 IF crtPanel%=7 THEN
15160   filelen$=GetFLen(LeftFiles$,LIndex%)
15170   ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
15180   FOR i%=LIndex%+1 TO LSizedir%+LSizeFile%
15190     CopyRec LeftFiles$,i% TO LeftFiles$,i%-1
15200   END FOR i%
15210   LSizeFile%=LSizeFile%-1
15220   x%=Find%(NewFileName$,id%, LeftFiles$,LSizedir%+1,LSizedir%+LSizeFile%)
15230   x%=Insert%(NewFileName$,id%,LeftFiles$,0, LSizedir%, LSizeFile%, filelen$)
15240   LIndex%=id%
15250   x%=id%+(LMinPos%=0)
15260   page%=x% DIV rowno%
15270   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
15280   LStartPos%=(page%-1)*rowno% +LMinPos%
15290   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
15300 ELSE
15310   filelen$=GetFLen(RightFiles$,RIndex%)
15320   ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
15330   FOR i%=RIndex%+1 TO RSizedir%+RSizeFile%
15340     CopyRec RightFiles$,i% TO RightFiles$,i%-1
15350   END FOR i%
15360   RSizeFile%=RSizeFile%-1
15370   x%=Find%(NewFileName$,id%, RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
15380   x%=Insert%(NewFileName$,id%,RightFiles$,0, RSizedir%, RSizeFile%, filelen$)
15390   RIndex%=id%
15400   x%=id%+(RMinPos%=0)
15410   page%=x% DIV rowno%
15420   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
15430   RStartPos%=(page%-1)*rowno% +RMinPos%
15440   ListFiles RightFiles$, RStartPos%, RIndex%, 8
15450 END IF
15460 END DEFine RenameFile
15470 REMark -----------------------------------------------------------------------
15480 DEFine PROCedure ShowInfo
15490  LOCal filename$(36), path$(36), chf%, ch%,ch1%,ch2%,x%, k$(2),windef$, left%, top%
15500   :
15510   IF crtPanel%=7 THEN
15520     IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
15530   ELSE
15540     IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
15550   END IF
15560   :
15570   IF crtPanel%=7 THEN
15580     filename$=GetFNam$(LeftFiles$,LIndex%)
15590     path$=leftDir$
15600   ELSE
15610     filename$=GetFNam$(RightFiles$,RIndex%)
15620     path$=rightDir$
15630   END IF
15640   :
15650   IF filename$='..' THEN RETurn : END IF
15660   left%=(maxWinWid%-452) DIV 2
15670   IF maxWinHgt%>256 THEN top%=51: ELSE top%=14: END IF
15680   windef$="scr_452x230a"&left%&"x"&top%
15690   ch%=FOPEN(windef$)
15700   PAPER #ch%,0:INK #ch%,White%
15710   OUTLN #ch%,452,230,left%,top% : BORDER #ch%,1,2: CLS #ch%
15720   windef$="scr_452x12a"&left%&"x"&top%
15730   ch1%=FOPEN(windef$): BORDER #ch1%,1,2 : PAPER #ch1%,0,2,1 : CLS #ch1%
15740   PAPER #ch1%,0 : INK #ch1%,White% : AT #ch1%,0,34 : PRINT#ch1%, ' Info '
15750   windef$="scr_448x204a"&(left%+2)&"x"&(top%+12)
15760   ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
15770   PRINT #ch2%, 'Full name: ';path$&filename$;CHR$(10);
15780   :
15790   chf%=FOPEN(path$&filename$)
15800   IF chf%<0 THEN
15810     INK#ch2%, 2
15820     SELect ON chf%
15830       =-7: PRINT#ch2%, 'File Not Found !'
15840       =-9: PRINT#ch2%, 'File in use'
15850       = REMAINDER : PRINT#ch2%, 'Error ';chf%
15860     END SELect
15870     INK 4
15880   ELSE
15890     GetHEAD #chf%,headBuff
15900     PRINT#ch2%, 'File Length:'; : PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff)
15910     x%=PEEK(headBuff+5)
15920     PRINT#ch2%, 'File Type:   ';x%;' - ';
15930     SELect ON x%
15940       =0  : PRINT#ch2%, 'BASIC, CALLable machine code, extensions or DATA file'
15950       =1  : PRINT#ch2%, 'EXECable file'
15960       =2  : PRINT#ch2%, 'SROFF file used by linkers etc, a C68 Library file etc'
15970       =3  : PRINT#ch2%, 'THOR hard disc directory file. (I think!)'
15980       =4  : PRINT#ch2%, 'A font file for The Painter'
15990       =5  : PRINT#ch2%, 'A pattern file for The Painter'
16000       =6  : PRINT#ch2%, 'A compressed MODE 4 screen in The Painter'
16010       =11 : PRINT#ch2%, 'A compressed MODE 8 screen in The Painter'
16020       =255: PRINT#ch2%, 'Level 2 driver directory or sub-directory file'
16030       =REMAINDER : PRINT#ch2%,' '
16040     END SELect
16050     PRINT#ch2%, 'Data-space: ';
16060     IF x%=1 THEN PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff+6) : ELSE : PRINT#ch2%, "   n/a"
16070     PRINT#ch2%, 'File Version:  ';PEEK_W(headBuff+56)
16080     PRINT#ch2%, 'Last modified: ';
16090     d=PEEK_L(headBuff+52) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
16100     PRINT#ch2%, 'Backup date:   ';
16110     d=PEEK_L(headBuff+60) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
16120     CLOSE #chf%
16130   END IF
16140   :
16150   PRINT#ch2%, CHR$(10);'------------------------------------------------------------------------';CHR$(10)
16160   PRINT#ch2%, 'ROM Version:  '; VER$
16170   PRINT#ch2%, 'QDOS Version: '; VER$(1)
16180   PRINT#ch2%, 'Current RAMTOP: '; : PRINT_USING#ch2%, "##,###.#",RESPR(0)/1024-128 : PRINT#ch2%, ' Kb'
16190   PRINT#ch2%, 'Free memory:    '; : PRINT_USING#ch2%, "##,###.#",FREE_MEM/1024     : PRINT#ch2%, ' Kb'
16200   PRINT#ch2%
16210   PRINT#ch2%, 'DataD$: ';DATAD$
16220   PRINT#ch2%, 'ProgD$: ';PROGD$
16230   PRINT#ch2%, 'DestD$: ';DESTD$
16240   :
16250   k$=INKEY$(-1)
16260   CLS #ch1% : CLS #ch2% : CLOSE #ch2% : CLOSE #ch1%
16270   OUTLN #ch%,452,230,left%,top%
16280   CLOSE #ch%
16290   :
16300 END DEFine ShowInfo
16310 REMark -----------------------------------------------------------------------
16320 DEFine PROCedure WriteCommands(ch%)
16330  LOCal lat, px%, px1%, i%, x%, lat%(9)
16340   lat=(comWinWid% - 4) DIV 9: rest=(comWinWid% - 4) MOD 9:FOR i%=1 TO 9:lat%(i%)=lat:NEXT i%
16350   IF rest>=0 THEN lat%(4)=lat+1
16360   IF rest>=1 THEN lat%(3)=lat+1
16370   IF rest>=2 THEN lat%(5)=lat+1
16380   IF rest>=3 THEN lat%(1)=lat+1
16390   IF rest>=4 THEN lat%(2)=lat+1
16400   IF rest>=5 THEN lat%(6)=lat+1
16410   IF rest>=6 THEN lat%(7)=lat+1
16420   IF rest>=7 THEN lat%(8)=lat+1
16430   IF rest>=8 THEN lat%(9)=lat+1
16440   px%=0
16450   PAPER#ch%, PPR9a%,ppr9b%,3
16460   :
16470   FOR i%=1 TO 9
16480     BLOCK#ch%, lat%(i%)-1,mainFountHeight%, px%,0, PPR9a%,ppr9b%,3
16490     x%=px% + (lat%(i%) - 1 - LEN(cmdText$(i%)) * comFountWid%) DIV 2
16500     CURSOR#ch%, x%,0 : PRINT#ch%, cmdText$(i%);
16510     px%=px%+lat%(i%)
16520   END FOR i%
16530 END DEFine WriteCommands
16540 REMark -----------------------------------------------------------------------
16550 DEFine FuNction IsReadOnly% (a$)
16560 LOCal res%
16570 res%=FOPEN(a$&CHR$(0))
16580 IF res%=-20 THEN RETurn 1: END IF
16590 IF res%>0 THEN DELETE a$&CHR$(0): END IF
16600 RETurn 0
16610 END DEFine IsReadOnly%
16620 REMark -----------------------------------------------------------------------
16630 DEFine PROCedure CopyFiles
16640 LOCal k%, x%, name$, source$, dest$, filelen$, panel%
16650 x%=CountSelected%
16660 IF crtPanel%=7 THEN
16670   source$=leftDir$ : dest$=rightDir$
16680   name$=GetFNam$(LeftFiles$,LIndex%)
16690   filelen$=GetFLen(LeftFiles$,LIndex%)
16700   panel%=8
16710 ELSE
16720   dest$=leftDir$ : source$=rightDir$
16730   name$=GetFNam$(RightFiles$,RIndex%)
16740   filelen$=GetFLen(RightFiles$,RIndex%)
16750   panel%=7
16760 END IF
16770 IF IsReadOnly%(dest$) THEN
16780  MessageWnd 200,60,2, CHR$(10)&'    Destination is Read Only! '&CHR$(10)&'           Cannot copy!'
16790  RETurn
16800 END IF
16810 IF x%>0 THEN
16820  k%=DlgWnd%(240,60,' Copy Files ', '    Are you sure you want to copy'&CHR$(10)&'     '&x%&' files and directories ?')
16830  IF k%=1 THEN CopyMultipleFiles x%
16840 ELSE
16850  IF IsDir%=1 THEN
16860      CopySingleDir name$, source$, dest$, panel%
16870  ELSE
16880    IF LEN(dest$&name$)>41 THEN
16890      MessageWnd 200,60,2, CHR$(10)&'        Cannot copy file'&CHR$(10)&'          Name too long !'
16900      RETurn
16910    END IF
16920    k%=FTEST(dest$&name$)
16930    IF k%=-7 THEN
16940     IF crtPanel%=7 THEN
16950       IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
16960         MessageWnd 200,60,2, CHR$(10)&'        Cannot copy file'&CHR$(10)&'      maximum number reached !'
16970         RETurn
16980       END IF
16990      ELSE
17000       IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
17010         MessageWnd 200,60,2, CHR$(10)&'        Cannot copy file'&CHR$(10)&'      maximum number reached !'
17020         RETurn
17030       END IF
17040      END IF
17050      Copy1File name$, source$, dest$, filelen$, 1: RETurn
17060    ELSE
17070      IF k%=0 THEN
17080        x%=DlgWnd%(240,60,' Copy Files ', '   Destination file already exists'&CHR$(10)&'              Overwrite ?')
17090        IF x%=1 THEN Copy1File name$, source$, dest$, filelen$, 1: RETurn :END IF
17100      ELSE
17110        SELect ON k%
17120          =-9: MessageWnd 200,60,2, CHR$(10)&'      Destination is in use '&CHR$(10)&'           Cannot copy!':RETurn
17130          =-11:MessageWnd 200,60,2, CHR$(10)&'    Destination drive is full'&CHR$(10)&'           Cannot copy!':RETurn
17140          =-16:MessageWnd 200,60,2, CHR$(10)&'      Bad or Changed Medium'&CHR$(10)&'           Cannot copy!':RETurn
17150          =-20:MessageWnd 200,60,2, CHR$(10)&'    Destination is Read Only! '&CHR$(10)&'           Cannot copy!': RETurn
17160          =REMAINDER : MessageWnd 200,60,2, CHR$(10)&'     Error copying file : '&k%:RETurn
17170        END SELect
17180      END IF
17190    END IF
17200  END IF
17210  IF crtPanel%=7 THEN
17220    id%=RIndex%+(RMinPos%=0)
17230    page%=id% DIV rowno%
17240    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
17250    RStartPos%=(page%-1)*rowno% +RMinPos%
17260    ListFiles RightFiles$, RStartPos%, RIndex%, 8
17270  ELSE
17280    id%=LIndex%+(LMinPos%=0)
17290    page%=id% DIV rowno%
17300    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
17310    LStartPos%=(page%-1)*rowno% +LMinPos%
17320    ListFiles LeftFiles$, LStartPos%, LIndex%, 7
17330  END IF
17340 END IF
17350 END DEFine CopyFiles
17360 REMark -----------------------------------------------------------------------
17370 DEFine PROCedure Copy1File (name$, source$, dest$, filelen$, UpdateList%)
17380 LOCal x%, page%
17390 COPY_O source$&name$ TO dest$&name$
17400 IF crtPanel%=8 THEN
17410   x%=Find%(name$,id%, LeftFiles$,LSizedir%+1,LSizedir%+LSizeFile%)
17420   IF x%=0 THEN
17430     x%=Insert%(name$,id%,LeftFiles$,0, LSizedir%, LSizeFile%, filelen$)
17440   ELSE
17450     PutFLen LeftFiles$,id%,filelen$
17460   END IF
17470   LIndex%=id%
17480   IF UpdateList%=1 THEN
17490     id%=id%+(LMinPos%=0)
17500     page%=id% DIV rowno%
17510     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
17520     LStartPos%=(page%-1)*rowno% +LMinPos%
17530     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
17540   END IF
17550 ELSE
17560   x%=Find%(name$,id%, RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
17570   IF x%=0 THEN
17580     x%=Insert%(name$,id%,RightFiles$,0, RSizedir%, RSizeFile%, filelen$):
17590   ELSE
17600     PutFLen RightFiles$,id%,filelen$
17610   END IF
17620   RIndex%=id%
17630   IF UpdateList%=1 THEN
17640     id%=id%+(RMinPos%=0)
17650     page%=id% DIV rowno%
17660     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
17670     RStartPos%=(page%-1)*rowno% +RMinPos%
17680     ListFiles RightFiles$, RStartPos%, RIndex%, 8
17690   END IF
17700 END IF
17710 END DEFine Copy1File
17720 REMark -----------------------------------------------------------------------
17730 DEFine PROCedure CopyDirFiles(name$, source$, dest$, CreateWnd%)
17740 LOCal ch%, ch1%
17750 IF CreateWnd%=1 THEN
17760   ch%=FOPEN("scr_400x156a56x50")
17770   PAPER #ch%,0:INK #ch%,7
17780   OUTLN #ch%,400,156,56,50:BORDER#ch%,1,2:CLS#ch%
17790   ch1%=FOPEN("scr_398x12a57x51"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
17800   PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,25: PRINT#ch1%, ' Copy Directory '
17810   WINDOW#0,396, 140, 58, 63:PAPER#0,0: INK#0,White%:CLS#0
17820 END IF
17830 PRINT#0, 'Copy '&source$&name$&' to '&dest$&name$
17840 WCOPY source$&name$ TO dest$&name$
17850 IF CreateWnd%=1 THEN
17860   INK#0,Green%:PRINT#0, 'Copy process ended - press any key to close window':INK#0,White%
17870   x%=KEYROW(0):a$=INKEY$(-1)
17880   WINDOW#0,448,12,32,231:
17890   CLOSE#ch1%
17900   OUTLN #ch%,400,156,56,50
17910   CLOSE#ch%
17920 END IF
17930 END DEFine CopyDirFiles
17940 REMark -----------------------------------------------------------------------
17950 DEFine PROCedure CopyMultipleFiles(k%)
17960 LOCal ch%, ch1%, i%, x%, a$, Index%, panel%, page%, id%, left%,windef$, hgt%, wid%
17970 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
17980 hgt%=panelWinHeight%*8 DIV  10
17990 left%=(maxWinWid%-wid%) DIV 2
18000 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
18010 ch%=FOPEN(windef$)
18020 PAPER #ch%,0:INK #ch%,White%
18030 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
18040 left%=left%+1
18050 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
18060 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
18070 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, ' Copy Selected '
18080 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
18090 PRINT#0, 'Copy Selected list: '&k%&' files and/or directories'
18100 IF crtPanel%=7 THEN
18110  source$=leftDir$:dest$=rightDir$: Index%=LIndex%: panel%=8
18120  FOR i%=1 TO LSizedir%+LSizeFile%
18130    LIndex%=i%
18140    IF GetFFlg%(LeftFiles$,i%) > 1 THEN
18150      IF GetFFlg%(LeftFiles$,i%) = 2 THEN
18160        PRINT#0, 'Copying file '&GetFNam$(LeftFiles$,i%)&' ...'
18170        x%=CopyAListFile%(GetFNam$(LeftFiles$,i%), source$, dest$, GetFLen(LeftFiles$,i%), 8)
18180      ELSE
18190        PRINT#0, 'Copying directory '&GetFNam$(LeftFiles$,i%)&' ...'
18200        x%=CopyFullDir%(GetFNam$(LeftFiles$,i%), source$, dest$, 8, 0, 1, 1)
18210      END IF
18220      IF x%=-1 THEN EXIT i%
18230      PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
18240    END IF
18250  NEXT i%: END FOR i%
18260  LIndex%=Index%
18270 ELSE
18280  source$=rightDir$:dest$=leftDir$:Index%=RIndex%
18290  FOR i%=1 TO RSizedir%+RSizeFile%
18300    RIndex%=i%
18310    IF GetFFlg%(RightFiles$,i%) > 1 THEN
18320      IF GetFFlg%(RightFiles$,i%)=2 THEN
18330        PRINT#0, 'Copying file '&GetFNam$(RightFiles$,i%)&' ...'
18340        x%=CopyAListFile%(GetFNam$(RightFiles$,i%), source$, dest$, GetFLen(RightFiles$,i%), 7)
18350      ELSE
18360        PRINT#0, 'Copying directory '&GetFNam$(RightFiles$,i%)&' ...'
18370        x%=CopyFullDir% (GetFNam$(RightFiles$,i%), source$, dest$, 7, 0, 1, 1)
18380      END IF
18390      IF x%=-1 THEN EXIT i%
18400      PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
18410    END IF
18420  NEXT i%: END FOR i%
18430  RIndex%=Index%
18440 END IF
18450 INK#0,Green%:PRINT#0, 'Copy process ended - press any key to close window':INK#0,White%
18460 x%=KEYROW(0):a$=INKEY$(-1)
18470 WINDOW#0,448,12,32,231:
18480 CLOSE#ch1%
18490 OUTLN #ch%,wid%,hgt%,left%-1,50
18500 CLOSE#ch%
18510 id%=RIndex%+(RMinPos%=0)
18520 page%=id% DIV rowno%
18530 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
18540 RStartPos%=(page%-1)*rowno% +RMinPos%
18550 ListFiles RightFiles$, RStartPos%, RIndex%, 8
18560 id%=LIndex%+(LMinPos%=0)
18570 page%=id% DIV rowno%
18580 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
18590 LStartPos%=(page%-1)*rowno% +LMinPos%
18600 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
18610 END DEFine CopyMultipleFiles
18620 REMark -----------------------------------------------------------------------
18630 DEFine FuNction CopyAListFile%(name$, source$, dest$, filelen$, panel%)
18640 LOCal k%
18650  IF LEN(dest$&name$)>41 THEN
18660    INK#0,2: PRINT#0,name$&' not copied. Name too long':INK#0,White%
18670    RETurn 0
18680  END IF
18690  k%=FTEST(dest$&name$)
18700  IF k%=-7 THEN
18710   IF panel%=8 THEN
18720     IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
18730       INK#0,2: PRINT#0,'Maximum number reached on destination directory!':INK#0,White%
18740       RETurn -1
18750     END IF
18760   ELSE
18770     IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
18780       INK#0,2: PRINT#0,'Maximum number reached on destination directory!':INK#0,White%
18790       RETurn -1
18800     END IF
18810   END IF
18820   Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
18830  ELSE
18840    IF k%=0 THEN
18850      PRINT#0,'File already exists Overwrite (Y/N) ?'
18860      REPeat loopa
18870        a$=INKEY$(-1)
18880        IF a$ INSTR 'yYnN' THEN EXIT loopa: END IF
18890      END REPeat loopa
18900      IF a$='y' OR a$='Y' THEN
18910        Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
18920      ELSE
18930        RETurn 0
18940      END IF
18950    ELSE
18960      SELect ON k%
18970        =-9: INK#0,2: PRINT#0,name$&'not copied. Destination is in use':INK#0,White%:RETurn 0
18980        =-11:INK#0,2: PRINT#0,name$&'not copied. Destination drive is full':INK#0,White%:RETurn -1
18990        =-16:INK#0,2: PRINT#0,name$&'not copied. Destination Bad or Changed Medium':INK#0,White%:RETurn -1
19000        =-20:INK#0,2: PRINT#0,name$&'not copied. Destination is Read Only! ':INK#0,White%: RETurn 0
19010        =REMAINDER : INK#0,2: PRINT#0,name$&'not copied. Error '&k%:INK#0,White%:RETurn 0
19020      END SELect
19030    END IF
19040  END IF
19050 END DEFine CopyAListFile%
19060 REMark -----------------------------------------------------------------------
19070 DEFine PROCedure DeleteFiles
19080 LOCal source$, name$, panel%, x%, k%, a$, ch%,ch1%, Index%,left%,windef$,hgt%, wid%
19090 IF crtPanel%=7 THEN
19100  source$=leftDir$: name$=GetFNam$(LeftFiles$,LIndex%):panel%=7: Index%=LIndex%
19110 ELSE
19120  source$=rightDir$: name$=GetFNam$(RightFiles$,RIndex%):panel%=8: Index%=RIndex%
19130 END IF
19140 IF IsReadOnly%(source$) THEN
19150  MessageWnd 200,60,2, CHR$(10)&'       Drive is Read Only! '
19160  RETurn
19170 END IF
19180 x%=CountSelected%
19190 IF x%>0 THEN
19200  k%=DlgWnd%(240,60,' Delete Files ', '   Are you sure you want to delete'&CHR$(10)&'     '&x%&' files and directories ?')
19210 ELSE
19220  IF IsDir%=1 THEN
19230    a$='directory '&name$
19240  ELSE
19250    a$='file '&name$
19260  END IF
19270  k%=(39-LEN(a$))DIV 2: IF k%<0 THEN k%=0
19280  a$='   Are you sure you want to delete'&CHR$(10)&FILL$(' ',k%)&a$
19290  k%=DlgWnd%(240,60,' Delete File ',a$)
19300 END IF
19310 IF k%=0 THEN RETurn
19320 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
19330 hgt%=panelWinHeight%*8 DIV  10
19340 left%=(maxWinWid%-wid%) DIV 2
19350 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
19360 ch%=FOPEN(windef$)
19370 PAPER #ch%,0:INK #ch%,White%
19380 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
19390 left%=left%+1
19400 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
19410 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
19420 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-84) DIV 2,0: PRINT#ch1%, ' Delete Files '
19430 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
19440 IF x%=0 THEN
19450   IF IsDir%=0
19460     PRINT#0, 'Deleting file '&source$&name$
19470     DELETE source$&name$
19480   ELSE
19490     IF DeleteDirectory (source$, name$)=0 THEN INK#0,2:PRINT#0, 'Could not delete all of '&source$&name$&'_': INK#0,White%
19500   END IF
19510 ELSE
19520   PRINT#0, 'Delete Selected list: '&x%&' files and/or directories'
19530   IF crtPanel%=7 THEN
19540     FOR k%=1 TO LSizedir%+LSizeFile%
19550       IF GetFFlg%(LeftFiles$,k%) > 1 THEN
19560         IF GetFFlg%(LeftFiles$,k%)=2 THEN
19570           PRINT#0, 'Deleting file '&GetFNam$(LeftFiles$,k%)&' ...'
19580           DELETE source$&GetFNam$(LeftFiles$,k%)
19590         ELSE
19600           IF DeleteDirectory (source$, GetFNam$(LeftFiles$,k%)) =0 THEN INK#0,2:PRINT#0, 'Could not delete all of '&source$&GetFNam$(LeftFiles$,k%)&'_': INK#0,White%
19610         END IF
19620       END IF
19630     NEXT k%: END FOR k%
19640   ELSE
19650     FOR k%=1 TO RSizedir%+RSizeFile%
19660       IF GetFFlg%(RightFiles$,k%) > 1 THEN
19670         IF GetFFlg%(RightFiles$,k%)=2 THEN
19680           PRINT#0, 'Deleting file '&GetFNam$(RightFiles$,k%)&' ...'
19690           DELETE source$&GetFNam$(RightFiles$,k%)
19700         ELSE
19710           IF DeleteDirectory (source$, GetFNam$(RightFiles$,k%)) THEN INK#0,2:PRINT#0, 'Could not delete all of '&source$&GetFNam$(RightFiles$,k%)&'_': INK#0,White%
19720         END IF
19730       END IF
19740     NEXT k%: END FOR k%
19750   END IF
19760 END IF
19770 INK#0,Green%:PRINT#0, 'Delete process ended - press any key to close window':INK#0,White%
19780 x%=KEYROW(0):a$=INKEY$(-1)
19790 WINDOW#0,448,12,32,231:
19800 CLOSE#ch1%
19810 OUTLN #ch%,wid%,hgt%,left%-1,50
19820 CLOSE#ch%
19830 IF crtPanel%=7 THEN
19840   ReloadPanel 7, Index%
19850 ELSE
19860   ReloadPanel 8, Index%
19870 END IF
19880 END DEFine DeleteFiles
19890 REMark -----------------------------------------------------------------------
19900 DEFine PROCedure EXecFile
19910 LOCal filename$, path$, chf%, x%
19920 IF crtPanel%=7 THEN
19930  IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
19940  filename$=GetFNam$(LeftFiles$,LIndex%)
19950  path$=leftDir$
19960 ELSE
19970  IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
19980  filename$=GetFNam$(RightFiles$,RIndex%)
19990  path$=rightDir$
20000 END IF
20010 chf%=FOPEN(path$&filename$)
20020 IF chf%<0 THEN
20030   SELect ON chf%
20040    =-7:  MessageWnd 200,60,2, CHR$(10)&'         File Not Found !'
20050    =-9:  MessageWnd 200,60,2, CHR$(10)&'           File in use'
20060    = REMAINDER :  MessageWnd 200,60,2, CHR$(10)& '             Error '&chf%
20070  END SELect
20080  ELSE
20090   CLOSE#chf%
20100   x%=FTYP(\path$&filename$)
20110   IF x%<>1 THEN
20120     MessageWnd 200,60,2, CHR$(10)&'   This is not a EXECable file'
20130   ELSE
20140     EX path$&filename$
20150   END IF
20160 END IF
20170 END DEFine EXecFile
20180 REMark -----------------------------------------------------------------------
20190 DEFine FuNction getKey$(c%)
20200  LOCal k$(2)
20210   CURSEN #c%
20220   k$=INKEY$(c%,-1)
20230   CURDIS #c%
20240   RETurn k$
20250 END DEFine getKey$
20260 REMark -----------------------------------------------------------------------
20270 DEFine PROCedure OnEnter
20280 LOCal ext$(10), path$, a$, x%, i%
20290 IF crtPanel%=7 THEN
20300   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
20310   a$=GetFNam$(LeftFiles$,LIndex%)
20320   path$=leftDir$
20330 ELSE
20340   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
20350   a$=GetFNam$(RightFiles$,RIndex%)
20360   path$=rightDir$
20370 END IF
20380 IF a$=='..' OR IsDir%=1 THEN
20390   IF crtPanel%=7 THEN
20400     OpenSubDir LeftFiles$, LIndex%, 7
20410   ELSE
20420     OpenSubDir RightFiles$, RIndex%, 8
20430   END IF
20440   RETurn
20450 END IF
20460 IF FTYP(\path$&a$) =1 THEN
20470   EXecFile
20480   RETurn
20490 END IF
20500 REMark now get file extension
20510 x%=LEN(a$)
20520 FOR i%=0 TO x%-1
20530 IF a$(x%-i%)=='_' THEN EXIT i%
20540 NEXT i%: END FOR i%
20550 IF i%>0 THEN
20560   ext$=a$(x%-i% TO x%)
20570 ELSE
20580   ext$=''
20590 END IF
20600 ext$=LOWER$(ext$):x%=0
20610 IF ext$='_bas' THEN x%=1
20620 IF ext$='_cde' OR ext$='_code' OR ext$='_rext' THEN x%=2
20630 IF ext$='_zip' THEN x%=3
20640 IF ext$='_doc' THEN x%=4
20650 IF ext$='_aba' THEN x%=5
20660 IF ext$='_grf' THEN x%=6
20670 IF ext$='_dbf' THEN x%=7
20680 IF ext$='_prg' THEN x%=8
20690 IF a$='boot' THEN x%=1
20700 SELect ON x%
20710   =1: LoadBasFile path$&a$
20720   =2: DoLrespr path$&a$
20730   =3: IF IsZipFile%(path$&a$)=1 THEN UnzipFile path$&a$
20740   =4: IF IsQuillDoc%(path$&a$)=1 THEN
20750         IF Xchangeprog$<>'' THEN
20760           ExecXchange path$, path$&a$
20770         END IF
20780       END IF
20790   =5: IF IsAbacusDoc%(path$&a$)=1 THEN
20800         IF Xchangeprog$<>'' THEN
20810           ExecXchange path$, path$&a$
20820         END IF
20830       END IF
20840   =6: IF Xchangeprog$<>'' THEN
20850         ExecXchange path$, path$&a$
20860       END IF
20870   =7: IF IsArchiveDoc%(path$&a$)=1 THEN
20880         IF Xchangeprog$<>'' THEN
20890           ExecXchange path$, path$&a$
20900         END IF
20910       END IF
20920   =8: x%=DlgWnd%(240,60,' Archive Prg ', '     '&a$&CHR$(10)&'      Open with Xchange Archive ?')
20930       IF x%=0 THEN RETurn
20940       ExecXchange path$, path$&a$
20950 END SELect
20960 END DEFine OnEnter
20970 REMark -----------------------------------------------------------------------
20980 DEFine PROCedure UnzipFile (filename$)
20990 LOCal path$, ch%, ch1%, ch2%
21000 IF crtPanel%=7 THEN
21010   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
21020   path$=rightDir$
21030 ELSE
21040   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
21050   path$=leftDir$
21060 END IF
21070 ch%=DlgWnd%(240,60,' Unzip File ', '    Are you sure you want to unzip'&CHR$(10)&'     '&filename$&' ?')
21080 IF ch%=0 THEN RETurn
21090 ch%=FOPEN("scr_452x230a30x14")
21100 PAPER #ch%,0:INK #ch%,7
21110 OUTLN #ch%,452,230,30,14:BORDER#ch%,1,2:CLS#ch%
21120 ch1%=FOPEN("scr_452x12a31x14"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
21130 PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,37-(LEN(a$)+5)/2: PRINT#ch1%, 'Unzip'&a$
21140 ch2%=FOPEN("scr_448x204a32x26"):PAPER#ch2%,0:INK#ch2%,4
21150 EW ConfigDrv$&'unzip', #ch2%;'-D'&path$&' -o '&filename$
21160 PRINT #ch2%, 'Press any key ...'
21170 path$=INKEY$(-1)
21180 CLS#ch1%: CLS#ch2%: CLOSE#ch2%:CLOSE#ch1%
21190 WINDOW#0,488,23,12,233:PAPER#0,0:INK#0,White%
21200 OUTLN #ch%,452,230,30,14
21210 CLOSE#ch%
21220  IF crtPanel%=7 THEN
21230     ReloadPanel 8,RIndex%
21240  ELSE
21250     ReloadPanel 7,LIndex%
21260  END IF
21270 END DEFine UnzipFile
21280 REMark -----------------------------------------------------------------------
21290 DEFine PROCedure ExecXchange(path$, filename$)
21300  LOCal savedDATAD$(36), savedPROGD$(36)
21310   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
21320   DATA_USE path$
21330   PROG_USE Xchangepath$
21340   EX Xchangepath$&Xchangeprog$; filename$
21350   DATA_USE savedDATAD$
21360   PROG_USE savedPROGD$
21370 END DEFine ExecXchange
21380 REMark -----------------------------------------------------------------------
21390 DEFine PROCedure EditFile(path$, filename$)
21400  LOCal savedDATAD$(36), savedPROGD$(36)
21410   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
21420   DATA_USE path$
21430   PROG_USE EditPath$
21440   EX EditPath$&Editprog$; path$&filename$
21450   DATA_USE savedDATAD$
21460   PROG_USE savedPROGD$
21470 END DEFine EditFile
21480 REMark -----------------------------------------------------------------------
21490 DEFine PROCedure LoadBasFile(filename$)
21500 LOCal x%
21510 IF isBasicRunning=1 THEN
21520   MessageWnd 200,60,2, CHR$(10)&'        BASIC is running'&CHR$(10)&'       Cannot load _bas now!'
21530   RETurn
21540 END IF
21550 IF (isBasicProgramLoaded>0) AND (isBasicProgramEdited=1) THEN
21560   x%=DlgWnd%(240,60,' Basic program loaded ', '       A Basic program is loaded'&CHR$(10)&'         Loose any changes made?')
21570   IF x%=0 THEN RETurn
21580 END IF
21590 COMMAND_LINE
21600 PAUSE 5
21610 TYPE_IN 'Load '&filename$ & CHR$(10)
21620 TYPE_IN 'ED' & CHR$(10)
21630 END DEFine LoadBas
21640 REMark -----------------------------------------------------------------------
21650 DEFine PROCedure DoEdit
21660 LOCal path$, a$
21670 IF crtPanel%=7 THEN
21680   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
21690   a$=GetFNam$(LeftFiles$,LIndex%)
21700   path$=leftDir$
21710 ELSE
21720   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
21730   a$=GetFNam$(RightFiles$,RIndex%)
21740   path$=rightDir$
21750 END IF
21760 IF IsDir%(path$&a$)=1 THEN RETurn
21770 IF IsQuillDoc%(path$&a$)=1 THEN
21780   IF Xchangeprog$<>'' THEN
21790     ExecXchange path$, path$&a$
21800     RETurn
21810   END IF
21820 ELSE
21830   EditFile path$, a$
21840 END IF
21850 END DEFine DoEdit
21860 REMark -----------------------------------------------------------------------
21870 DEFine PROCedure DoLrespr (filename$)
21880 LOCal x%
21890 x%=DlgWnd%(240,60,' LRESPR File ', '    Are you sure you want to LRESPR'&CHR$(10)&'     '&filename$&' ?')
21900 IF x%=0 THEN RETurn
21910 COMMAND_LINE
21920 PAUSE 5
21930 TYPE_IN 'LRESPR '&filename$&CHR$(10)
21940 END DEFine DoLrespr
21950 REMark -----------------------------------------------------------------------
21960 DEFine FuNction IsAbacusDoc%(a$)
21970 LOCal ch%, q$, i%, k%
21980 ch% = FOPEN(a$)
21990 IF ch% <= 0 THEN RETurn 0: END IF
22000 q$=''
22010 FOR i%=1 TO 4
22020  BGET #ch%,k%
22030  q$=q$&CHR$(k%)
22040 NEXT i%: END FOR i%
22050 CLOSE #ch%
22060 IF q$='ABM1' THEN RETurn 1: ELSE RETurn 0: END IF
22070 END DEFine IsAbacusDoc%
22080 REMark -----------------------------------------------------------------------
22090 DEFine FuNction IsArchiveDoc%(a$)
22100 LOCal ch%, q$, i%, k%
22110 ch% = FOPEN(a$)
22120 IF ch% <= 0 THEN RETurn 0: END IF
22130 q$=''
22140 BGET #ch%\1,k%
22150 FOR i%=1 TO 8
22160  BGET #ch%,k%
22170  q$=q$&CHR$(k%)
22180 NEXT i%: END FOR i%
22190 CLOSE #ch%
22200 IF q$='vrm1dbf0' THEN RETurn 1: ELSE RETurn 0: END IF
22210 END DEFine IsArchiveDoc%
22220 REMark -----------------------------------------------------------------------
22230 DEFine PROCedure ReloadPanel(panel%, Index%)
22240 LOCal page%, x%
22250 IF panel%=7 THEN
22260   DIM LeftFiles$(MaxFiles%,_fMax%)
22270   LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
22280   IF LEN(leftDir$)=5 THEN
22290     LMinPos%=1
22300   ELSE
22310     LMinPos%=0
22320   END IF
22330   IF Index%<LMinPos% THEN Index%=LMinPos%
22340   IF Index%>LSizedir%+LSizeFile% THEN Index%=LMinPos%
22350   LIndex%=Index%
22360   x%=Index%+(LMinPos%=0)
22370   page%=x% DIV rowno%
22380   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
22390   LStartPos%=(page%-1)*rowno% +LMinPos%
22400   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
22410 ELSE
22420   DIM RightFiles$(MaxFiles%,_fMax%)
22430   LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
22440   IF LEN(rightDir$)=5 THEN
22450     RMinPos%=1
22460   ELSE
22470     RMinPos%=0
22480   END IF
22490   IF Index%<RMinPos% THEN Index%=RMinPos%
22500   IF Index%>RSizedir%+RSizeFile% THEN Index%=RMinPos%
22510   RIndex%=Index%
22520   x%=Index%+(RMinPos%=0)
22530   page%=x% DIV rowno%
22540   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
22550   RStartPos%=(page%-1)*rowno% +RMinPos%
22560   ListFiles RightFiles$, RStartPos%, RIndex%, 8
22570 END IF
22580 END DEFine ReloadPanel
22590 REMark -----------------------------------------------------------------------
22600 DEFine PROCedure SelectAll
22610 LOCal i%
22620 IF crtPanel%=7 THEN
22630   FOR i%=1 TO LSizedir%+LSizeFile%
22640     IF GetFFlg%(LeftFiles$,i%) < 2 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
22650   END FOR i%
22660   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
22670 ELSE
22680   FOR i%=1 TO RSizedir%+RSizeFile%
22690     IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
22700   END FOR i%
22710   ListFiles RightFiles$, RStartPos%, RIndex%, 8
22720 END IF
22730 END DEFine SelectAll
22740 REMark -----------------------------------------------------------------------
22750 DEFine PROCedure UnSelectAll
22760 LOCal i%
22770 IF crtPanel%=7 THEN
22780   FOR i%=1 TO LSizedir%+LSizeFile%
22790     IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
22800   END FOR i%
22810   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
22820 ELSE
22830   FOR i%=1 TO RSizedir%+RSizeFile%
22840     IF GetFFlg%(RightFiles$,i%) > 1 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
22850   END FOR i%
22860   ListFiles RightFiles$, RStartPos%, RIndex%, 8
22870 END IF
22880 END DEFine UnSelectAll
22890 REMark -----------------------------------------------------------------------
22900 DEFine PROCedure Set78CharSet
22910 REMark On QPC2 the char width gets reset so we have to set it again
22920 IF mainFountBase>0 THEN
22930   IF ClassicFont%=0 THEN
22940     CHAR_USE #leftPanelWin%,mainFountBase,0
22950     CHAR_INC #leftPanelWin%,5,10
22960     CHAR_USE #rightPanelWin%,mainFountBase,0
22970     CHAR_INC #rightPanelWin%,5,10
22980   END IF
22990 END IF
23000 END DEFine Set78CharSet
23010 REMark -----------------------------------------------------------------------
23020 DEFine FuNction TestFount%(fountBase)
23030  LOCal fountMask%,fountMax%,char%,row%
23040   fountMask%=3 : REMark *** ------XX
23050   fountMax%=PEEK(fountBase+1)
23060   FOR char%=0 TO fountMax%
23070     FOR row%=0 TO 8
23080       IF PEEK(fountBase+2 + char%*9 + row%) && fountMask% THEN RETurn 2 : REMark *** appears to be a FAT fount
23090     END FOR row%
23100   END FOR char%
23110   :
23120   RETurn 1 : REMark *** Does not appear to be a FAT fount
23130   :
23140 END DEFine TestFount%
23150 REMark -----------------------------------------------------------------------
23160 REFERENCE fList$(0,0)
23170 DEFine FuNction GetFNam$(fList$,fIndex%)
23180   RETurn fList$(fIndex%,3 TO 2 + STRING%(fList$(fIndex%,1 TO 2)))
23190 END DEFine GetFNam$
23200 REMark -----------------------------------------------------------------------
23210 REFERENCE fList$(0,0)
23220 DEFine FuNction GetFLen(fList$,fIndex%)
23230   RETurn LONGINTEGER(fList$(fIndex%,_fLen% TO _fTyp%-1))
23240 END DEFine GetFLen
23250 REMark -----------------------------------------------------------------------
23260 REFERENCE fList$(0,0)
23270 DEFine FuNction GetFTyp%(fList$)
23280   RETurn STRING%(fList$(fIndex%,_fTyp% TO _fDat%-1))
23290 END DEFine GetFTyp%
23300 REMark -----------------------------------------------------------------------
23310 REFERENCE fList$(0,0)
23320 DEFine FuNction GetFDat(fList$,fIndex%)
23330   RETurn LONGINTEGER(fList$(fIndex%,_fDat% TO _fPar%-1))
23340 END DEFine GetFDat
23350 REMark -----------------------------------------------------------------------
23360 REFERENCE fList$(0,0)
23370 DEFine FuNction GetFPar%(fList$,fIndex%)
23380   RETurn STRING%(fList$(fIndex%,_fPar% TO _fFlg%-1))
23390 END DEFine GetFPar%
23400 REMark -----------------------------------------------------------------------
23410 REFERENCE fList$(0,0)
23420 DEFine FuNction GetFFlg%(fList$,fIndex%)
23430   RETurn STRING%(fList$(fIndex%,_fFlg% TO _fMax%))
23440 END DEFine GetFFlg%
23450 REMark -----------------------------------------------------------------------
23460 REFERENCE fList$(0,0)
23470 DEFine PROCedure PutFNam(fList$,fIndex%,newVal$)
23480  LOCal nVLen%
23490   nVLen%=LEN(newVal$)
23500   IF nVLen%>maxFNLen% THEN nVLen%=maxFNLen%
23510   fList$(fIndex%,1 TO 2+nVLen%)=STRING$(newVal$(1 TO nVLen%))
23520 END DEFine PutFNam
23530 REMark -----------------------------------------------------------------------
23540 REFERENCE fList$(0,0)
23550 DEFine PROCedure PutFLen(fList$,fIndex%,newVal)
23560   fList$(fIndex%,_fLen% TO _fTyp%-1)=LONGINTEGER$(newVal)
23570 END DEFine PutFLen
23580 REMark -----------------------------------------------------------------------
23590 REFERENCE fList$(0,0)
23600 DEFine PROCedure PutFTyp(fList$,fIndex%,newVal%)
23610   fList$(fIndex%,_fTyp% TO _fDat%-1)=INTEGER$(newVal%)
23620 END DEFine PutFTyp
23630 REMark -----------------------------------------------------------------------
23640 REFERENCE fList$(0,0)
23650 DEFine PROCedure PutFDat(fList$,fIndex%,newVal)
23660   fList$(fIndex%,_fDat% TO _fPar%-1)=LONGINTEGER$(newVal)
23670 END DEFine PutFDat
23680 REMark -----------------------------------------------------------------------
23690 REFERENCE fList$(0,0)
23700 DEFine PROCedure PutFPar(fList$,fIndex%,newVal%)
23710   fList$(fIndex%,_fPar% TO _fFlg%-1)=INTEGER$(newVal%)
23720 END DEFine PutFPar
23730 REMark -----------------------------------------------------------------------
23740 REFERENCE fList$(0,0)
23750 DEFine PROCedure PutFFlg(fList$,fIndex%,newVal%)
23760   fList$(fIndex%,_fFlg% TO _fMax%)=INTEGER$(newVal%)
23770 END DEFine PutFFlg
23780 REMark -----------------------------------------------------------------------
23790 REFERENCE fList$(0,0),fListDest$(0,0)
23800 DEFine PROCedure CopyRec(fList$,fIndex%,fListDest$,fDestIndex%)
23810   fListDest$(fDestIndex%, 1 TO _fMax%)=fList$(fIndex%, 1 TO _fMax%)
23820 END DEFine CopyRec
23830 REMark -----------------------------------------------------------------------
23840 DEFine FuNction isBasicRunning
23850   IF BASIC_B%(111)<> 0 THEN
23860     RETurn 0
23870   ELSE
23880     IF BASIC_B%(143) = 0 : RETurn 0 : REMark break - Ctrl-Space pressed
23890     IF BASIC_W%(104) = BASIC_W%(146) : RETurn 0 : REMark STOP occurred
23900     RETurn 1 : REMark Program is running
23910   END IF
23920 END DEFine isBasicRunning
23930 REMark -----------------------------------------------------------------------
23940 DEFine FuNction  isBasicProgramLoaded
23950 RETurn BASIC_W%(BASIC_L(16))
23960 END DEFine isBasicProgramLoaded
23970 REMark -----------------------------------------------------------------------
23980 REFERENCE fList$(0,0),r_StartPos%,r_Index%
23990 DEFine PROCedure MoveTop(fList$, r_StartPos%, r_Index%, ch%)
24000 LOCal top%, x%, size%
24010 IF ch%=7 THEN
24020   r_StartPos%= LMinPos%
24030 ELSE
24040   r_StartPos%=RMinPos%
24050 END IF
24060 r_Index%=r_StartPos%
24070 ListFiles fList$, r_StartPos%, r_Index%, ch%
24080 END DEFine MovePageUp
24090 REMark -----------------------------------------------------------------------
24100 REFERENCE fList$(0,0),r_StartPos%,r_Index%
24110 DEFine PROCedure MoveLast(fList$, r_StartPos%, r_Index%, ch%)
24120 LOCal top%
24130 IF ch%=7 THEN
24140   top%= LMinPos%
24150   r_Index%=LSizeFile%+LSizedir%
24160 ELSE
24170   top%=RMinPos%
24180   r_Index%=RSizeFile%+RSizedir%
24190 END IF
24200 r_StartPos%=r_Index%-19
24210 IF r_StartPos%<top% THEN r_StartPos%=top%
24220 ListFiles fList$, r_StartPos%, r_Index%, ch%
24230 END DEFine MoveLast
24240 REMark -----------------------------------------------------------------------
24250 DEFine PROCedure LRUNBasic
24260 LOCal i%, a$, path$, ext$
24270 IF crtPanel%=7 THEN
24280   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
24290   a$=GetFNam$(LeftFiles$,LIndex%)
24300   path$=leftDir$
24310 ELSE
24320   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
24330   a$=GetFNam$(RightFiles$,RIndex%)
24340   path$=rightDir$
24350 END IF
24360 IF a$=='..' OR IsDir%=1 THEN RETurn
24370 REMark now get file extension
24380 x%=LEN(a$)
24390 FOR i%=0 TO x%-1
24400 IF a$(x%-i%)=='_' THEN EXIT i%
24410 NEXT i%: END FOR i%
24420 IF i%>0 THEN
24430   ext$=a$(x%-i% TO x%)
24440 ELSE
24450   ext$=''
24460 END IF
24470 ext$=LOWER$(ext$)
24480 IF ext$<>'_bas' AND a$<>'boot' THEN RETurn
24490 IF isBasicRunning=1 THEN
24500   MessageWnd 200,60,2, CHR$(10)&'        BASIC is running'&CHR$(10)&'       Cannot run _bas now!'
24510   RETurn
24520 END IF
24530 IF (isBasicProgramLoaded>0) AND (isBasicProgramEdited=1) THEN
24540   i%=DlgWnd%(240,60,' Basic program loaded ', '       A Basic program is loaded'&CHR$(10)&'         Loose any changes made?')
24550   IF i%=0 THEN RETurn
24560 END IF
24570 COMMAND_LINE
24580 PAUSE 5
24590 TYPE_IN CHR$(27)&CHR$(27)&CHR$(27):PAUSE 5
24600 TYPE_IN 'LRUN '&path$&a$ & CHR$(10)
24610 END DEFine LRUNBasic
24620 REMark -----------------------------------------------------------------------
24630 DEFine PROCedure SetPalletteQL
24640 PALETTE_QL 0,0,0,255*256*256,255*256*256,255*256,255*256,255*256*256+255*256+255,255*256*256+255*256+255
24650 END DEFine SetPalletteQL
24660 REMark -----------------------------------------------------------------------
24670 DEFine FuNction isBasicProgramEdited
24680 IF BASIC_B%(142)=255 THEN
24690    RETurn 1
24700 ELSE
24710    RETurn 0
24720 END IF
24730 END DEFine isBasicProgramEdited
24740 REMark -----------------------------------------------------------------------
24750 DEFine FuNction CopyFullDir%(name$, source$, dest$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
24760 LOCal x%, ch%, loop, d$, fp, newname$, newsource$, newdest$, totrim
24770 IF DirExists%(dest$&name$)=0 THEN
24780   x%=Create1Dir%(name$, dest$&name$,panel%,0,CheckNoQ%, UpdateList%)
24790   IF x%=0 THEN RETurn 0
24800 END IF
24810 PRINT#0, 'Copy '&source$&name$&' to '&dest$&name$
24820 WCOPY source$&name$ TO dest$&name$
24830 ch% = FOP_DIR (source$&name$) : REMark open channel to directory
24840 IF ch% < 0 THEN RETurn : REMark unable to open directory
24850 fp = 14 : REMark file position in directory for filename
24860 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>'_' THEN newsource$=newsource$&'_'
24870 newdest$=dest$&name$: IF newdest$(LEN(newdest$))<>'_' THEN newdest$=newdest$&'_'
24880 REPeat loop
24890   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
24900   GET #ch%,d$ : REMark get a directory entry name
24910   IF LEN(d$) > 0 THEN
24920     REMark a directory length of 0 may be a deleted file
24930     BGET #ch%\fp-9 : REMark file type byte
24940     IF CODE(INKEY$(#ch%)) = 255 THEN
24950       REMark this is a subdirectory, so we need to copy this
24960       REMark Extract file name and check length
24970       totrim=LEN(newsource$)-4
24980       newname$=d$(totrim TO)
24990       IF LEN(newdest$&newname$)>36 THEN
25000         INK#0,2:PRINT#0,'Directory '&newdest$&newname$&' not created  Name too long':INK#0,White%
25010       ELSE
25020         x%=CopyFullDir%(newname$, newsource$, newdest$, panel%, 0,0,0)
25030       END IF
25040     END IF
25050   END IF
25060   fp = fp + 64
25070 END REPeat loop
25080 RETurn 1
25090 END DEFine CopyFullDir%
25100 REMark -----------------------------------------------------------------------
25110 DEFine PROCedure CopySingleDir(name$, source$, dest$, panel%)
25120 LOCal ch%, ch1%, i%, x%, a$, Index%, page%, id%, left%,windef$, hgt%, wid%
25130 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
25140 hgt%=panelWinHeight%*8 DIV  10
25150 left%=(maxWinWid%-wid%) DIV 2
25160 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
25170 ch%=FOPEN(windef$)
25180 PAPER #ch%,0:INK #ch%,White%
25190 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
25200 left%=left%+1
25210 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
25220 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
25230 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, ' Copy Directory '
25240 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
25250 PRINT#0, 'Copy Directory '&source$&name$&' to '&dest$
25260 res%=CopyFullDir% (name$, source$, dest$, panel%,0,1,0)
25270 INK#0,Green%:PRINT#0, 'Copy process ended - press any key to close window':INK#0,White%
25280 x%=KEYROW(0):a$=INKEY$(-1)
25290 WINDOW#0,448,12,32,231:
25300 CLOSE#ch1%
25310 OUTLN #ch%,wid%,hgt%,left%-1,50
25320 CLOSE#ch%
25330 REMark If copy OK then Add the dir name to the list in the destination panel and refresh screen
25340 IF res%=1 THEN
25350   IF panel%=8 THEN
25360     res%=Find% (name$,id%,RightFiles$,1,RSizedir%)
25370     IF res%=0 THEN
25380       res%=Insert% (name$,id%, RightFiles$, 1, RSizedir%, RSizeFile%, '0')
25390       RIndex%=id%
25400       id%=id%+(RMinPos%=0)
25410       page%=id% DIV rowno%
25420       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
25430       RStartPos%=(page%-1)*rowno% +RMinPos%
25440       ListFiles RightFiles$, RStartPos%, RIndex%, 8
25450     END IF
25460   ELSE
25470     res%=Find% (name$,id%,LeftFiles$,1,LSizedir%)
25480     IF res%=0 THEN
25490       res%=Insert% (name$,id%, LeftFiles$, 1, LSizedir%, LSizeFile%, '0')
25500       LIndex%=id%
25510       id%=id%+(LMinPos%=0)
25520       page%=id% DIV rowno%
25530       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
25540       LStartPos%=(page%-1)*rowno% +LMinPos%
25550       ListFiles LeftFiles$, LStartPos%, LIndex%, 7
25560     END IF
25570   END IF
25580 END IF
25590 END DEFine CopySingleDir
25600 REMark -----------------------------------------------------------------------
25610 DEFine FuNction DeleteDirectory(source$, name$)
25620 LOCal ch%, loop, d$, newsource$, newname$, fp, totrim, x%
25630 IF name$(LEN(name$))<>'_' THEN name$=name$&'_'
25640 PRINT#0, 'Deleting directory '&source$&name$&'...'
25650 WDEL source$&name$
25660 ch% = FOP_DIR (source$&name$) : REMark open channel to directory
25670 IF ch% < 0 THEN RETurn : REMark unable to open directory
25680 fp = 14 : REMark file position in directory for filename
25690 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>'_' THEN newsource$=newsource$&'_'
25700 REPeat loop
25710   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
25720   GET #ch%,d$ : REMark get a directory entry name
25730   IF LEN(d$) > 0 THEN
25740     REMark a directory length of 0 may be a deleted file
25750     BGET #ch%\fp-9 : REMark file type byte
25760     IF CODE(INKEY$(#ch%)) = 255 THEN
25770       REMark this is a subdirectory, so we need to delete this
25780       REMark Extract file name and check length
25790       totrim=LEN(newsource$)-4
25800       newname$=d$(totrim TO)
25810       x%=DeleteDirectory (newsource$, newname$)
25820     END IF
25830   END IF
25840   fp = fp + 64
25850 END REPeat loop
25860 REMark Now check that directory is empty
25870 IF isDirEmpty(source$&name$)=1 THEN
25880   DELETE source$&name$
25890   RETurn 1
25900 ELSE
25910   RETurn 0
25920 END IF
25930 END DEFine DeleteDirectory
25940 REMark -----------------------------------------------------------------------
25950 DEFine FuNction isDirEmpty(DirName$)
25960 LOCal ch%, fp, d$, loop, res%
25970 ch% = FOP_DIR (DirName$) : REMark open channel to directory
25980 IF ch% < 0 THEN RETurn 0: REMark unable to open directory
25990 res%=1
26000 fp = 14 : REMark file position in directory for filename
26010 REPeat loop
26020   BGET #ch%\fp : IF EOF(#ch%) THEN : EXIT loop
26030   GET #ch%,d$ : REMark get a directory entry name
26040   IF LEN(d$) > 0 THEN res%=0: EXIT loop: REMark if file name >0 then we found a file and we set result to 1
26050   fp = fp + 64
26060 END REPeat loop
26070 CLOSE#ch%
26080 RETurn res%
26090 END DEFine isDirEmpty
26100 REMark -----------------------------------------------------------------------
26110 DEFine PROCedure CompareDirs
26120 LOCal i%, res%
26130 REMark Unselect all left files
26140 FOR i%=1 TO LSizedir%+LSizeFile%
26150   IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
26160 END FOR i%
26170 REMark Select all right files
26180 FOR i%=1 TO RSizedir%+RSizeFile%
26190   IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
26200 END FOR i%
26210 REMark Parse left directory list and compare it to right
26220 FOR i%= 1 TO LSizedir%
26230   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,1,RSizedir%)
26240   IF res%=0 THEN
26250     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
26260   ELSE
26270     PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
26280   END IF
26290 NEXT i%: END FOR i%
26300 REMark Parse left file list and compare it to right
26310 FOR i%= LSizedir%+1 TO LSizedir%+LSizeFile%
26320   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
26330   IF res%=0 THEN
26340     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
26350   ELSE
26360     IF GetFLen(LeftFiles$,i%)=GetFLen(RightFiles$,id%) THEN
26370       PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
26380     ELSE
26390       PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
26400     END IF
26410   END IF
26420 NEXT i%: END FOR i%
26430 REMark refresh screen
26440 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
26450 ListFiles RightFiles$, RStartPos%, RIndex%, 8
26460 END DEFine CompareDirs
26470 REMark -----------------------------------------------------------------------
26480 DEFine PROCedure InvertSelection
26490 LOCal i%
26500 IF crtPanel%=7 THEN
26510   FOR i%=1 TO LSizedir%+LSizeFile%
26520     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
26530   END FOR i%
26540   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
26550 ELSE
26560   FOR i%=1 TO RSizedir%+RSizeFile%
26570     PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
26580   END FOR i%
26590   ListFiles RightFiles$, RStartPos%, RIndex%, 8
26600 END IF
26610 END DEFine InvertSelection
