1000 REMark **************************************
1010 REMark *                                    *
1020 REMark *  QLCommander v2.0 Config program   *
1030 REMark *                                    *
1040 REMark **************************************
1050 REMark *    can load v1.1 config files      *
1060 REMark * Needs Toolkit II and Turbo Toolkit *
1070 REMark **************************************
1080 :
1090 ClearScreen
1100 WINDOW#1,448,240,32,6:
1110 PAPER 0:INK 7:BORDER 1,7:CLS#1
1120 WINDOW#2, 448,50,32,196: PAPER#2, 4:INK#2, 7:BORDER#2,1,7:CLS#2
1130 Init
1140 DrawTitle
1150 SetupLines:ShowCommands:ShowCursor 1:ShowComment
1160 DoMain
1170 Terminate
1180 DEFine PROCedure DrawTitle
1190 BLOCK 444,20,0,0,2
1200 CSIZE#1, 2,0: INK#1, 0: PAPER#1, 2: CURSOR#1, 72,6:PRINT#1, 'QL Commander Configurator'
1210 INK#1, 7: CURSOR#1, 71,5:OVER#1, 1:PRINT#1, 'QL Commander Configurator'
1220 BLOCK 444,2,0,20,7
1230 END DEFine DrawTitle
1240 DEFine PROCedure Init
1250 DIM text$(14,2,36): DIM Comments$(14,256)
1260 text$(1,0)='Save config to  : ' :text$(1,1)='win1_QLCOMMANDER_':text$(1,2)=36
1270 text$(2,0)='Temp dir path:  : ' :text$(2,1)='win2_Temp_'       :text$(2,2)=36
1280 text$(3,0)='No of files     : ' :text$(3,1)='256'              :text$(3,2)=3
1290 text$(4,0)='Left panel dir  : ' :text$(4,1)='win1_'            :text$(4,2)=36
1300 text$(5,0)='Right panel dir : ' :text$(5,1)='win2_'            :text$(5,2)=36
1310 text$(6,0)='QUBIDE drive    : ' :text$(6,1)='0'                :text$(6,2)=1
1320 text$(7,0)='Fount           : ' :text$(7,1)='1'                :text$(7,2)=1
1330 text$(8,0)='Chars per line  : ' :text$(8,1)='40'               :text$(8,2)=2
1340 text$(9,0)='No of rows      : ' :text$(9,1)='30'               :text$(9,2)=2
1350 text$(10,0)='XChange path    : ':text$(10,1)='win1_XCHANGE_'   :text$(10,2)=36
1360 text$(11,0)='XChange name    : ':text$(11,1)='XCHANGE'         :text$(11,2)=36
1370 text$(12,0)='Editor path     : ':text$(12,1)='win1_qd2018_'    :text$(12,2)=36
1380 text$(13,0)='Editor name     : ':text$(13,1)='qd_english'      :text$(13,2)=36
1390 text$(14,0)='QL colours      : ':text$(14,1)='0'               :text$(14,2)=36
1400 Comments$(1)=CHR$(10)&' This is the directory where QLCommander is installed'&CHR$(10)&' Config file qlc_cfg will be saved or loaded from this directory'
1410 Comments$(2)=CHR$(10)&' This is the temporary directory used by QLCommander. The directory must   be available at all times.'
1420 Comments$(3)=CHR$(10)&' Maximum number of files and directories that will be shown in a panel.    If the selected directory has more files and subdirectories that the      number selected (N), then only the first N will be loaded and shown.'
1430 Comments$(4)=CHR$(10)&' Initial directory to load in the left panel'
1440 Comments$(5)=CHR$(10)&' Initial directory to load in the right panel'
1450 Comments$(6)=CHR$(10)&' Set value to: '&CHR$(10)&'    1 = if you are using a QUBIDE drive'&CHR$(10)&'    0 = if you are using any other type of storage'&CHR$(10)&'        (e.g. like QL_SD, QXL drive )'
1460 Comments$(7)=CHR$(10)&' Sets the fount that will be used in the panels.' &CHR$(10)&'   0 = 5x10 pixels narrow fount        1 = 6x10 pixels QL standard fount'&CHR$(10)&'   2 = 6x20 pixels fount, spaced 8 px  2 = 8x20 pixels fount spaced 12px'
1470 Comments$(8)=' Number of characters per panel line Can be set between 20 and 60'&CHR$(10)&' For standard QL resolution:'&CHR$(10)&'   if Fount=1 then line length should be between 36 and 42'&CHR$(10)&'   if Fount=0 then line length should be between 44 and 50, even number'
1480 Comments$(9)=CHR$(10)&' Number of rows in a panel. Can be set between 10 and 60.'&CHR$(10)&' For standard QL screen resolution set it to 20'&CHR$(10)&' If number of rows is greater than the resolution can support then         QLCommander will adjust it automatically'
1490 Comments$(10)=CHR$(10)&' The directory where XChange is installed.'&CHR$(10)&' Leave empty if you do not wish to edit XChange files'
1500 Comments$(11)=CHR$(10)&' Xchange EXECable filename (normally it is XChange)'
1510 Comments$(12)=CHR$(10)&' The directory where your editor is installed.'&CHR$(10)&' Leave empty if you do not wish to edit files'&CHR$(10)&' The editor must accept filename as parameter'
1520 Comments$(13)=CHR$(10)&" Your editor's  EXECable filename"
1530 Comments$(14)=CHR$(10)&' Sets the colour scheme:'&CHR$(10)&'   0 = use more colors (only on SMSQ/E in 8 bit or high color mode)'&CHR$(10)&'   1 = use the standard QL mode 4 color'
1540 crtline=1: left%=5
1550 END DEFine Init
1560 DEFine PROCedure SetupLines
1570 LOCal i
1580 CSIZE 0,0: INK 7:PAPER 0
1590 FOR i=1 TO 14
1600 AT 2+i,left%+3:PRINT text$(i,0);text$(i,1)
1610 END FOR i
1620 END DEFine SetupLines
1630 DEFine PROCedure SaveConfig
1640 LOCal a$
1650  a$=text$(1,1)&'qlc_cfg'
1660  Chan%=FOP_OVER(a$)
1670  IF Chan%>0
1680    REMark Maximum number of files and subdirs to load from a dir, including the fake dir ..-> (acts as DDUP)
1690    PRINT#Chan%, text$(3,1)
1700    REMark temporary dir used by some viewers
1710    PRINT#Chan%, text$(2,1)
1720    REMark Drive or dir to load in left panel at program start
1730    PRINT#Chan%, text$(4,1)
1740    REMark Drive or dir to load in right panel at program start
1750    PRINT#Chan%, text$(5,1)
1760    REMark If you have a QUBIDE drive set this to 1
1770    PRINT#Chan%,text$(6,1)
1780    REMark If ClassicFont%=1 then linelen% should be between 36 and 42
1790    REMark If ClassicFont%=0 then linelen% should be between 44 and 50 and even number !
1800    PRINT#Chan%, text$(7,1)
1810    REMark CHaracters per line
1820    PRINT#Chan%, text$(8,1)
1830    REMark Number of lines
1840    PRINT#Chan%,text$(9,1)
1850   REMark  Path to _doc editor
1860   PRINT#Chan%, text$(10,1)
1870   REMark Name of program for _doc editor
1880   PRINT#Chan%,text$(11,1)
1890   REMark Path to text editor
1900   PRINT#Chan%,text$(12,1)
1910   REMark Name of program for text editor
1920   PRINT#Chan%,text$(13,1)
1930   PRINT#Chan%,text$(14,1)
1940   CLOSE#Chan%
1950   CLS#2:INK#2,2:CSIZE#2,2,0: AT#2,1,2:PRINT#2,'Config file is saved !'
1960   PAUSE 100:
1970   ShowComment
1980 END IF
1990 END DEFine SaveConfig
2000 DEFine PROCedure ShowCommands
2010 LOCal y
2020 y=178: BLOCK 444,10,0,y,7: INK 0
2030 CURSOR 2, y :PRINT 'COMMANDS  ';
2040 INK 2:PRINT CHR$(190)&CHR$(191);:INK 0: PRINT ': Move cursor  ';
2050 INK 2:PRINT 'Enter';: INK 0:PRINT ': Edit value  ';
2060 INK 2:PRINT 'F1'; :INK 0:PRINT ': Save  ';
2070 INK 2:PRINT 'F3'; :INK 0:PRINT ': Load  ';
2080 INK 2:PRINT 'Q'; :INK 0:PRINT ': Quit'
2090 INK 7
2100 END DEFine ShowCommands
2110 DEFine PROCedure ClearScreen
2120 LOCal i
2130 WMON
2140 FOR i=0 TO 2
2150   PAPER#i,0:BORDER#i,0:CLS#i
2160 END FOR i
2170 END DEFine ClearScreen
2180 DEFine PROCedure Terminate
2190 LOCal i
2200 CLOSE#3
2210 FOR i=0 TO 2
2220   PAPER#i,0:BORDER#i,0:INK#i,7:CLS#i
2230 END FOR i
2240 WMON
2250 STOP
2260 END DEFine Terminate
2270 DEFine PROCedure ShowCursor(index)
2280 OVER -1:INK 2
2290 AT 2+index,left%:PRINT CHR$(185);CHR$(185):OVER 0
2300 END DEFine ShowCursor
2310 DEFine PROCedure CursorDown
2320 IF crtline<14 THEN
2330    ShowCursor(crtline)
2340    crtline=crtline+1
2350    ShowCursor(crtline):ShowComment
2360 END IF
2370 END DEFine CursorDown
2380 DEFine PROCedure CursorUp
2390 IF crtline>1 THEN
2400    ShowCursor(crtline)
2410    crtline=crtline-1
2420    ShowCursor(crtline): ShowComment
2430 END IF
2440 END DEFine CursorUp
2450 DEFine PROCedure DoMain
2460 LOCal x, loop
2470 REPeat loop
2480   x=CODE(INKEY$(-1))
2490   SELect ON x
2500     = 208:CursorUp
2510     = 216:CursorDown
2520     =  10:DoEdit
2530     = 232:SaveConfig
2540     = 240:ReadConfig
2550     = 81,113: EXIT loop
2560   END SELect
2570 END REPeat loop
2580 END DEFine DoMain
2590 DEFine PROCedure DoEdit
2600 SELect ON crtline
2610   =1,2,4,5 :EditStr 1,0
2620   =10,12   :EditStr 1,1
2630   =11,13   :EditStr 0,1
2640   =3       :EditInt 10,999
2650   =6,14    :EditInt 0,1
2660   =7       :EditInt 0,3
2670   =8       :EditInt 20,60
2680   =9       :EditInt 10,60
2690 END SELect
2700 END DEFine DoEdit
2710 DEFine PROCedure EditStr (isdir, canbenull)
2720 LOCal loop, x$
2730 x$=text$(crtline,1)
2740 BLOCK (text$(crtline,2)+1)*6,10,(left%+3+18)*6,(crtline+2)*10,7: INK 0 : PAPER 7
2750 REPeat loop
2760   AT 2+crtline, left%+3+18: x$=EDIT$(x$,text$(crtline,2))
2770   IF isdir=1 AND x$<>'' THEN
2780     IF x$(LEN(x$))<>'_' THEN x$=x$&'_': END IF
2790   END IF
2800   IF canbenull=0 THEN
2810     IF x$='' THEN
2820       BEEP 1000,100
2830     ELSE
2840       EXIT loop
2850     END IF
2860   ELSE
2870     EXIT loop
2880   END IF
2890 END REPeat loop
2900 text$(crtline,1)=x$
2910 BLOCK (text$(crtline,2)+1)*6,10,(left%+3+18)*6,(crtline+2)*10,0: INK 7: PAPER 0
2920 AT 2+crtline,left%+3+18:PRINT text$(crtline,1)
2930 END DEFine EditInt
2940 DEFine PROCedure EditInt (min, Max)
2950 LOCal loop, x
2960 x=text$(crtline,1)
2970 BLOCK (text$(crtline,2)+1)*6,10,(left%+3+18)*6,(crtline+2)*10,7: INK 0: PAPER 7
2980 REPeat loop
2990   AT 2+crtline, left%+3+18: x=EDIT%(x,text$(crtline,2))
3000   IF x>=min AND x<=Max THEN
3010     EXIT loop
3020   ELSE BEEP 1000,100
3030   END IF
3040 END REPeat loop
3050 text$(crtline,1)=x
3060 BLOCK (text$(crtline,2)+1)*6,10,(left%+3+18)*6,(crtline+2)*10,0: INK 7: PAPER 0
3070 AT 2+crtline,left%+3+18:PRINT text$(crtline,1)
3080 END DEFine EditInt
3090 DEFine PROCedure ShowComment
3100 INK#2,0:CSIZE#2,0,0:CLS#2
3110 PRINT#2,Comments$(crtline)
3120 END DEFine ShowComment
3130 DEFine PROCedure ReadConfig
3140 LOCal a$, oldstyle, Chan%
3150  oldstyle=0
3160  a$=text$(1,1)&'qlc_cfg'
3170  Chan%=FOP_IN(a$)
3180  IF Chan%>0
3190    REMark Maximum number of files and subdirs to load from a dir, including the fake dir ..-> (acts as DDUP)
3200    INPUT#Chan%, text$(3,1)
3210    REMark temporary dir used by some viewers
3220    INPUT#Chan%, text$(2,1)
3230    REMark Drive or dir to load in left panel at program start
3240    INPUT#Chan%, text$(4,1)
3250    REMark Drive or dir to load in right panel at program start
3260    INPUT#Chan%, text$(5,1)
3270    REMark If you have a QUBIDE drive set this to 1
3280    INPUT#Chan%,text$(6,1)
3290    REMark If ClassicFont%=1 then linelen% should be between 36 and 42
3300    REMark If ClassicFont%=0 then linelen% should be between 44 and 50 and even number !
3310    INPUT#Chan%, text$(7,1)
3320    REMark Characters per line
3330    INPUT#Chan%, text$(8,1)
3340    REMark Number of lines
3350    INPUT#Chan%,text$(9,1)
3360    a$=text$(9,1)
3370    IF LEN(a$)<>2 THEN
3380      oldstyle=1
3390    ELSE
3400      IF CODE (a$(1))<48 OR CODE (a$(1))>57 OR CODE (a$(2))<48 OR CODE (a$(2))>57 THEN oldstyle=1
3410    END IF
3420    IF oldstyle=1 THEN
3430      text$(10,1)=text$(9,1)
3440      text$(9,1)='30'
3450    END IF
3460    REMark  Path to _doc editor
3470    IF oldstyle=0 THEN
3480      INPUT#Chan%, text$(10,1)
3490    END IF
3500    REMark Name of program for _doc editor
3510    INPUT#Chan%,text$(11,1)
3520    REMark Path to text editor
3530    INPUT#Chan%,text$(12,1)
3540    REMark Name of program for text editor
3550    INPUT#Chan%,text$(13,1)
3560    REMark Colours
3570    IF oldstyle=0 THEN
3580      INPUT#Chan%,text$(14,1)
3590    ELSE
3600      text$(14,1)=0
3610    END IF
3620    CLOSE#Chan%
3630    ClearLines:SetupLines
3640    CLS#2:INK#2,2:CSIZE#2,2,0: AT#2,1,2:PRINT#2,'Config file is loaded !'
3650    PAUSE 100:
3660    ShowComment
3670  END IF
3680 END DEFine ReadConfig
3690 DEFine PROCedure ClearLines
3700 LOCal i
3710 CSIZE 0,0: INK 7:PAPER 0
3720 FOR i=1 TO 14
3730 AT 2+i,left%+3+18:PRINT '                                    '
3740 END FOR i
3750 END DEFine ClearLines
